''This is to check or modify or delete if the access keys
''at end of tranlation strings are the same as in
''source strings and if not change to the same.
''Please use it only when you exactly know what it does!
''(c) 2007-2008 by gnatix (Last modified on 2008.02.24)
''Modified by wanfu (Last modified on 2014.07.09)

Public Type STRING_INFO
	PreSpace			As String	'ַǰÿո
	EndSpace			As String	'ַÿո
	Spaces				As String	'ַݼǰո
	AccKey				As String	'ַݼ
	AccKeyIFR			As String	'ַݼ־
	AccKeyKey			As String	'ַݼַ
	EndString			As String	'ַֹ
	Shortcut			As String	'ַ
	PreString			As String	'ַݼǰַݼǰĿոֹ
	ExpString			As String	'ַݼǰַ
	AccKeyPos			As Integer	'ַݼλ
	AccKeyNum			As Integer	'ַݼ
	Length				As Integer	'ַ
	LineNum				As Integer	'ַ
End Type

Public Type CHECK_STRING_VALUE
	AscRange()			As Long
	Range				As String
End Type

Public Type UI_FILE
	FilePath			As String	'ļȫ·
	AppName				As String	'
	Version				As String	'汾
	LangName			As String	'
	LangID				As String	'ID
	Encoding			As String	'ַ
End Type

Public Type INIFILE_DATA
	Title				As String	'
	Item()				As String	'Ŀ
	Value()				As String	'ִֵ
End Type

Public UIFileList() As UI_FILE,UIDataList() As INIFILE_DATA,LangFile As String
Public PslLangDataList() As String
Public CheckHexStr() As CHECK_STRING_VALUE,CheckSkipStr() As String,RegExp As Object

Public StringSrc As STRING_INFO,StringTrn As STRING_INFO,MoveAcckey As String
Public ModifiedCount As Integer,AddedCount As Integer,MovedCount As Integer
Public DeledCount As Integer,ReplacedCount As Integer
Public AllCont As Long,AccKey As Long,EndChar As Long,Acceler As Long

Public DefaultCheckList() As String,DefaultProjectList() As String
Public AppRepStr As String,PreRepStr As String,cSelected() As String
Public CheckList() As String,CheckDataList() As String,CheckDataListBak() As String
Public ProjectList() As String,ProjectDataList() As String

Public Const Version = "2014.07.08"
Public Const Build = "140708"
Public Const ToUpdateCheckVersion = "2011.11.14"
Public Const CheckRegKey = "HKCU\Software\VB and VBA Program Settings\AccessKey\"
Public Const CheckFilePath = MacroDir & "\Data\PSLCheckAccessKeys.dat"
Public Const JoinStr = vbFormFeed  'vbBack
Public Const SubJoinStr = vbVerticalTab  'Chr$(1)
Public Const LngJoinStr = "|"
Public Const SubLngJoinStr = Chr$(1)

Public Const ConvertStrHexRange = "\x30-\x39,\x41-\x46;\x30-\x39,\x41-\x46;\x30-\x37"
			'0=ʮת,1= Unicode ת,2=ڰ˽ת
Public Const CheckStrHexRange = "\x00-\x07,\x0E-\x1F;\x00-\x40,\x5B-\x60,\x7B-\xBF;" & _
								"\x00-\x60,\x7B-\xBF;\x00-\x40,\x5B-\xBF;\x41-\x5A,\x61-\x7A;" & _
								"\x30-\x39,\x41-\x5A,\x61-\x7A"
			'0=ַ,1=ȫΪֺͷ,2=ȫΪдӢ,3=ȫΪСдӢ,4=СдӢ,5=ݼַΧ
Public Const AppName = "PSLCheckAccessKeys"

Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
	ByRef Destination As Any, _
	ByRef Source As Any, _
	ByVal Length As Long)


'ִĬ
Function CheckSettings(ByVal DataName As String,ByVal DataType As Long) As String
	Dim i As Long,j As Long,CheckName As String,File As String
	Dim TempList() As String,DataList() As INIFILE_DATA

	If DataType = 0 Then
		ReDim TempList(17) As String
	Else
		ReDim TempList(20) As String
	End If

	If DataName <> "" Then
		If DataType = 0 Then
			Select Case DataName
			Case DefaultCheckList(0)
				CheckName = "en2zh"
			Case DefaultCheckList(1)
				CheckName = "zh2en"
			End Select
		ElseIf DataType = 1 Then
			Select Case DataName
			Case DefaultProjectList(0)
				CheckName = "CheckOnly"
			Case DefaultProjectList(1)
				CheckName = "CheckAndCorrect"
			Case DefaultProjectList(2)
				CheckName = "DelAccessKey"
			Case DefaultProjectList(3)
				CheckName = "DelAccelerator"
			Case DefaultProjectList(4)
				CheckName = "DelAccessKeyAndAccelerator"
			End Select
		End If
	End If
	If CheckName = "" Then GoTo ExitFunction

	File = MacroDir & "\Data\PSLCheckAccessKeys.ini"
	If getINIFile(DataList,File,"unicodeFFFE",1) = False Then GoTo NotReadFile

	On Error GoTo ErrMassage
	For i = 0 To UBound(DataList)
		With DataList(i)
			If .Title = "Option" Then
				For j = 0 To UBound(.Item)
					If .Item(j) = "Version" Then
						If StrComp(ToUpdateCheckVersion,.Value(j)) = 1 Then
							CheckName = ""
							Err.Raise(1,"NotVersion",File & JoinStr & .Value(j) & _
										JoinStr & ToUpdateCheckVersion)
							Exit For
						End If
					End If
				Next j
			ElseIf DataType = 0 And .Title = CheckName Then
				For j = 0 To UBound(.Item)
					Select Case .Item(j)
					Case "ExcludeChar"
						TempList(0) = .Value(j)
					Case "LineSplitChar"
						TempList(1) = .Value(j)
					Case "CheckBracket"
						TempList(2) = .Value(j)
					Case "KeepCharPair"
						TempList(3) = .Value(j)
					Case "ShowAsiaKey"
						TempList(4) = .Value(j)
					Case "CheckEndChar"
						TempList(5) = .Value(j)
					Case "NoTrnEndChar"
						TempList(6) = .Value(j)
					Case "AutoTrnEndChar"
						TempList(7) = .Value(j)
					Case "CheckShortChar"
						TempList(8) = .Value(j)
					Case "CheckShortKey"
						TempList(9) = .Value(j)
					Case "KeepShortKey"
						TempList(10) = .Value(j)
					Case "PreRepString"
						TempList(11) = .Value(j)
					Case "AutoRepString"
						TempList(12) = .Value(j)
					Case "AccessKeyChar"
						TempList(13) = .Value(j)
					Case "AddAccessKeyWithFirstChar"
						TempList(14) = .Value(j)
					Case "LineSplitMode"
						TempList(15) = .Value(j)
					Case "AppInsertSplitChar"
						TempList(16) = .Value(j)
					Case "ReplaceSplitChar"
						TempList(17) = .Value(j)
					End Select
				Next j
				CheckSettings = Join(TempList,SubJoinStr)
			ElseIf DataType = 1 And .Title = "Projects" Then
				For j = 0 To UBound(.Item)
					If .Item(j) = CheckName Then TempList = Split(.Value(j),LngJoinStr)
				Next j
				CheckSettings = Join(TempList,LngJoinStr)
			End If
		End With
	Next i

	If CheckSettings = "" And CheckName <> "" Then
		If DataType = 0 Then
			Temp = "NotSection"
		ElseIf DataType = 1 Then
			Temp = "NotValue"
		End If
		Err.Raise(1,Temp,File & JoinStr & CheckName)
	End If
	Exit Function

	NotReadFile:
	Err.Source = "NotReadFile"
	Err.Description = Err.Description & JoinStr & File

	ErrMassage:
	Call sysErrorMassage(Err,1)

	ExitFunction:
	If CheckSettings = "" Then
		If DataType = 0 Then
			CheckSettings = Join(TempList,SubJoinStr)
		ElseIf DataType = 1 Then
			CheckSettings = Join(TempList,LngJoinStr)
		End If
	End If
End Function


' 
Public Sub PSL_OnEditTransString(TransString As PslTransString)
	Dim i As Long,j As Long,n As Long,trn As PslTransList,Temp As String
	Dim srcString As String,trnString As String,OldTrnString As String,NewTrnString As String
	Dim LineNumErrCount As Integer,accKeyNumErrCount As Integer,ErrorCount As Integer
	Dim CheckID As Long,ProjectID As Long,ShowOriginalTran As Long,ApplyCheckResult As Long
	Dim Obj As Object,Stemp As Boolean
	Dim MsgList() As String,TempList() As String,TempArray() As String

	'רõûǷڣڼ˳
	Set trn = TransString.TransList
	If Not trn Is Nothing Then
		If trn.Property(19980) = "CheckAccessKeys" Then Exit Sub
	End If

	'δ롢ֻΪյִ
	If TransString.SourceText = TransString.Text Then Exit Sub
	If TransString.State(pslStateTranslated) = False Then Exit Sub
	If TransString.State(pslStateLocked) = True Then Exit Sub
	If TransString.State(pslStateReadOnly) = True Then Exit Sub
	If Trim(TransString.SourceText) = "" Then Exit Sub
	If Trim(TransString.Text) = "" Then Exit Sub

	'ϵͳ
	On Error Resume Next
	Set Obj = CreateObject("WScript.Shell")
	If Obj Is Nothing Then
		PSL.Output(Err.Description & " - " & "WScript.Shell")
		Exit Sub
	End If
	Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\Default"
	OSLanguage = Obj.RegRead(Temp)
	If OSLanguage = "" Then
		Temp = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\InstallLanguage"
		OSLanguage = Obj.RegRead(Temp)
		If Err.Source = "WshShell.RegRead" Then
			PSL.Output(Err.Description)
			Exit Sub
		End If
	End If
	Set Obj = Nothing

	' Adodb.Stream Ƿ
	Set Obj = CreateObject("Adodb.Stream")
	If Obj Is Nothing Then
		PSL.Output(Err.Description & " - " & "Adodb.Stream")
		Exit Sub
	End If
	Set Obj = Nothing

	' VBScript.RegExp Ƿ
	Set RegExp = CreateObject("VBScript.RegExp")
	If RegExp Is Nothing Then
		PSL.Output(Err.Description & " - " & "VBScript.RegExp")
		Exit Sub
	End If
	On Error GoTo SysErrorMsg

	'ʼ
	ReDim UIFileList(0) As UI_FILE,UIDataList(0) As INIFILE_DATA,PslLangDataList(0)
	ReDim DefaultCheckList(1),CheckList(0),CheckDataList(0),cSelected(26)
	ReDim DefaultProjectList(4),ProjectList(0),ProjectDataList(0)
	UIFileList(0).LangID = "0"

	'ת HEX ֵַΪ Long ʽģ壬תıת
	TempList = Split(ConvertStrHexRange,";")
	ReDim CheckHexStr(UBound(TempList)) As CHECK_STRING_VALUE
	For i = 0 To UBound(TempList)
		CheckHexStr(i).AscRange = HexToIntArray(Replace$(TempList(i),"\x",""))
		CheckHexStr(i).Range = Replace$(TempList(i),",","")
		If i = 0 Then
			CheckHexStr(i).Range = "\\x[" & CheckHexStr(i).Range & "]{2}"
		ElseIf i = 1 Then
			CheckHexStr(i).Range = "\\u[" & CheckHexStr(i).Range & "]{4}"
		ElseIf i = 2 Then
			CheckHexStr(i).Range = "\\[" & CheckHexStr(i).Range & "]+"
		End If
	Next i

	'תֵַΪʽģ壬ıʽȽ
	CheckSkipStr = Split("[" & Replace$(Replace$(CheckStrHexRange,";","];["),",","]|[") & "]",";")

	'ȡ
	GetCheckSet("Option","")

	'ȡִ
	If GetUIList(MacroDir & "\Data\",UIFileList) = True Then
		Temp = LCase$(cSelected(0))
		If Temp = "" Or Temp = "0" Then Temp = LCase$(OSLanguage)
		TempList = Split(Temp,";")
		For i = 1 To UBound(UIFileList)
			If LCase$(UIFileList(i).LangID) = Temp Then
				LangFile = UIFileList(i).FilePath
				Exit For
			End If
			TempArray = Split(LCase$(UIFileList(i).LangID),";")
			For j = 0 To UBound(TempList)
				For n = 0 To UBound(TempArray)
					If TempList(j) = TempArray(n) Then
						LangFile = UIFileList(i).FilePath
						Exit For
					End If
				Next n
				If LangFile <> "" Then Exit For
			Next j
			If LangFile <> "" Then Exit For
		Next i
	End If
	If LangFile = "" Then LangFile = MacroDir & "\Data\" & AppName & "_" & OSLanguage & ".lng"
	If Dir$(LangFile) = "" Then
		LangFile = MacroDir & "\Data\" & AppName & "_" & OSLanguage & ".lng"
		If Dir$(LangFile) = "" Then
			LangFile = ""
			For i = 0 To 2
				If i = 0 Then
					Temp = MacroDir & "\Data\" & AppName & "_0804.lng"
				ElseIf i = 1 Then
					Temp = MacroDir & "\Data\" & AppName & "_0404.lng"
				ElseIf UBound(UIFileList) > 0 Then
					Temp = UIFileList(1).FilePath
				End If
				If Dir$(Temp) <> "" Then
					LangFile = Temp
					Exit For
				End If
			Next i
			If LangFile = "" Then Err.Raise(1,"NotExitFile",MacroDir & "\Data\" & AppName & "_*.lng")
		End If
	End If
	If getINIFile(UIDataList,LangFile,"unicodeFFFE",0) = False Then Exit Sub
	If getMsgList(UIDataList,MsgList,"Main",0) = False Then Exit Sub

	' PSL 汾
	If PSL.Version < 600 Then
		PSL.Output(MsgList(47) & ":" & MsgList(49))
		Exit Sub
	End If

	'ȡִ
	DefaultCheckList(0) = MsgList(61)
	DefaultCheckList(1) = MsgList(62)
	DefaultProjectList(0) = MsgList(16)
	DefaultProjectList(1) = MsgList(17)
	DefaultProjectList(2) = MsgList(18)
	DefaultProjectList(3) = MsgList(74)
	DefaultProjectList(4) = MsgList(75)
	j = GetCheckSet("","")
	If j <> 4 Or UBound(CheckList) < 1 Then
		For i = LBound(DefaultCheckList) To UBound(DefaultCheckList)
			Stemp = False
			For j = LBound(CheckList) To UBound(CheckList)
				If CheckList(j) = DefaultCheckList(i) Then
					Stemp = True
					Exit For
				End If
			Next j
			If Stemp = False Then
				Temp = CheckSettings(DefaultCheckList(i),0)
				If Trim(Replace(Temp,SubJoinStr,"")) <> "" Then
					CreateArray(DefaultCheckList(i),DefaultCheckList(i) & JoinStr & Temp & JoinStr & _
								Join(LangCodeList(DefaultCheckList(i),1,108),SubLngJoinStr), _
								CheckList,CheckDataList)
				End If
			End If
		Next i
		If CheckArray(CheckList) = False Then
			PSL.Output MsgList(71)
			Exit Sub
		End If
	End If
	If CheckArray(ProjectList) = False Then
		For i = LBound(DefaultProjectList) To UBound(DefaultProjectList)
			Temp = CheckSettings(DefaultProjectList(i),1)
			If Trim(Replace(Temp,LngJoinStr,"")) <> "" Then
				CreateArray(DefaultProjectList(i),DefaultProjectList(i) & JoinStr & Temp,ProjectList,ProjectDataList)
			End If
		Next i
		If CheckArray(ProjectList) = False Then
			PSL.Output MsgList(71)
			Exit Sub
		End If
	End If
	AllCont = 1

	'ȡPSLĿԴ
	trnLng = PSL.GetLangCode(trn.Language.LangID,pslCode639_1)
	If trnLng = "zh" Or trnLng = "ja" Or trnLng = "ko" Then TranLang = "Asia"
	If trnLng = "" Or trnLng = "zh" Then
		trnLng = PSL.GetLangCode(trn.Language.LangID,pslCodeLangRgn)
		If trnLng = "zh-CHS" Or trnLng = "zh-SG" Then
			trnLng = "zh-CN"
		ElseIf trnLng = "zh-CHT" Or trnLng = "zh-HK" Or trnLng = "zh-MO" Then
			trnLng = "zh-TW"
		End If
	End If

	'ȡõļ
	CheckID = -1
	If StrToLong(cSelected(4)) = 1 Then
		CheckID = getCheckID(CheckDataList,trnLng,TranLang)
	Else
		For i = 0 To UBound(CheckList)
			If CheckList(i) = cSelected(1) Then
				CheckID = i
				Exit For
			End If
		Next i
	End If
	If CheckID = -1 Then CheckID = 0

	'ֵתеת
	CheckDataListBak = CheckDataList
	TempArray = Split(CheckDataList(CheckID),JoinStr)
	TempDataList = Split(TempArray(1),SubJoinStr)
	For i = 0 To UBound(TempDataList)
		If i <> 4 And i <> 14 And i <> 15 And i < 18 Then
			If TempDataList(i) <> "" Then
				If i = 1 Or i = 5 Or i = 13 Or i = 16 Or i = 17 Then
					If i = 5 Or i = 7 Then Temp = " " Else Temp = ","
					TempList = Split(TempDataList(i),Temp,-1)
					Call SortArrayByLength(TempList,0,UBound(TempList),True)
					TempDataList(i) = Convert(Join(TempList,Temp))
				Else
					TempDataList(i) = Convert(TempDataList(i))
				End If
			End If
		End If
	Next i
	TempArray(1) = Join(TempDataList,SubJoinStr)
	CheckDataList(CheckID) = Join(TempArray,JoinStr)
	CheckName = TempArray(0)

	'ҶӦļ鷽 ID 
	ProjectID = -1
	For i = LBound(ProjectDataList) To UBound(ProjectDataList)
		If Split(ProjectDataList(i),JoinStr)(0) = DefaultProjectList(1) Then
			ProjectID = i
			Exit For
		End If
	Next i
	If ProjectID = -1 Then ProjectID = 0

	'б־
	LineSplitCharArr = Split(Convert("\r\n,\r,\n"),",",-1)

	'ͷŲʹõĶ̬ʹõڴ
	Erase CheckList,TempList,TempDataList
	Erase TempArray,UIFileList

	'Ϣִʼȡԭĺͷִ
	srcString = TransString.SourceText
	trnString = TransString.Text

	'תת
	Stemp = False
	OldTrnString = trnString
	OldsrcString = srcString
	srcString = Convert(srcString)
	If srcString <> OldSrcString Then
		OldSrcString = srcString
		trnString = Convert(trnString)
		Stemp = True
	End If

	'ʼִ
	NewTrnString = CheckHanding(CheckID,srcString,trnString,ProjectID)
	If cSelected(25) = "1" Then NewTrnString = ReplaceStr(CheckID,NewTrnString,2,1)
	If Stemp = True Then NewTrnString = ReConvert(NewTrnString)

	'֯Ϣ
	If NewTrnString <> OldTrnString Then
		'
		For i = 0 To UBound(LineSplitCharArr)
			FindStr = Trim(LineSplitCharArr(i))
			If InStr(OldsrcString,FindStr) Then
				StringSrc.LineNum = StringSrc.LineNum + UBound(Split(OldsrcString,FindStr,-1))
			End If
			If InStr(NewTrnString,FindStr) Then
				StringTrn.LineNum = StringTrn.LineNum + UBound(Split(NewTrnString,FindStr,-1))
			End If
		Next i
		'Ϣ
		If StringSrc.LineNum <> StringTrn.LineNum Then
			LineMsg = LineErrMassage(StringSrc.LineNum,StringTrn.LineNum,LineNumErrCount)
		End If
		i = StringSrc.AccKeyNum - StringTrn.AccKeyNum
		If i > 1 Or i < 1 Then
			AcckeyMsg = AccKeyErrMassage(StringSrc.AccKeyNum,StringTrn.AccKeyNum,accKeyNumErrCount)
		End If
		TransString.OutputError(ReplaceMassage(CheckID,ProjectID) & AcckeyMsg & LineMsg)
	End If

	'滻ִ
	If NewTrnString <> OldTrnString Then
		'TransString.OutputError(MsgList(58) & OldtrnString)
		TransString.Text = NewTrnString
		trn.Save
	End If
	Exit Sub

	'ʾϢ
	SysErrorMsg:
	If Err.Source <> "ExitSub" Then Call sysErrorMassage(Err,0)
End Sub


'ִǷַָ(ıֵַȽ)
'Mode = 0 ִǷַָҳַָλ
'Mode = 1 ִǷַָֻ
'Mode = 2 ִǷַָ
'Mode = 3 ִǷֻСдַָ
'AscRange  ִ鷶Χ (ַ룬 Min - Max ʾΧ)
Public Function CheckStr(ByVal textStr As String,AscRange() As Long,Mode As Long) As Boolean
	Dim i As Long,j As Long,n As Long,k As Long,l As Long,m As Long
	Dim InpAsc As Long,Stemp As Boolean,FindStemp As Boolean
	Dim minVal As Long,maxVal As Long

	If AscRange(0) = 0 And AscRange(1) = 0 Then Exit Function
	If Trim$(textStr) = "" Then Exit Function
	If Mode = 3 Then
		If InStr(textStr," ") Then Exit Function
		If Len(textStr) < 3 Then Exit Function
	End If

	n = UBound(AscRange)
	For i = 1 To Len(textStr)
		InpAsc = AscW(Mid(textStr,i,1))
		FindStemp = False
		For j = 0 To n Step 2
			minVal = AscRange(j)
			maxVal = AscRange(j + 1)
			If minVal > -1 And maxVal > -1 Then
				If InpAsc >= minVal And InpAsc <= maxVal Then
					FindStemp = True
				End If
			ElseIf minVal > -1 And maxVal < 0 Then
				If InpAsc >= minVal Then FindStemp = True
			ElseIf minVal < 0 And maxVal > -1 Then
				If InpAsc <= maxVal Then FindStemp = True
			Else
				Exit For
			End If
			If FindStemp = True Then
				If Mode = 0 Then
					k = i
				ElseIf Mode = 3 Then
					If i > 1 Then
						If (j \ 2) And 1 Then l = l + 1 Else m = m + 1
					End If
				End If
				Exit For
			End If
		Next j
		If Mode = 1 Or Mode = 3 Then
			If FindStemp = False Then Stemp = True
		Else
			If FindStemp = True Then Stemp = True
		End If
		If Stemp = True Then Exit For
	Next i

	If Mode = 0 Or Mode = 2 Then
		If Stemp = True Then
			CheckStr = True
			If Mode = 0 Then Mode = k
		End If
	ElseIf Mode = 1 Then
		If Stemp = False Then CheckStr = True
	ElseIf Mode = 3 Then
		If Stemp = False And l > 0 And m > 0 Then CheckStr = True
	End If
End Function


'ִǷַָ(ʽȽ)
'Mode = 0 ִǷַָҳַָλ
'Mode = 1 ִǷַָֻ
'Mode = 2 ִǷַָ
'Mode = 3 ִǷֻСдַָ
'Mode = 4 ִǷַͬStrNum Ϊַ
'Patrn  Ϊʽģ
Public Function CheckStrRegExp(ByVal textStr As String,ByVal Patrn As String,ByVal StrNum As Long,Mode As Long) As Boolean
	Dim n As Long,Matches As Object
	If Patrn = "" Then Exit Function
	If Trim$(textStr) = "" Then Exit Function
	With RegExp
		Select Case Mode
		Case 0
			.Global = True
			.IgnoreCase = False
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count > 0 Then
				CheckStrRegExp = True
				Mode = Matches(0).FirstIndex + 1
			End If
		Case 1
			.Global = True
			.IgnoreCase = False
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count = Len(textStr) Then
				CheckStrRegExp = True
			End If
		Case 2
			.Global = False
			.IgnoreCase = False
			.Pattern = Patrn
			If .Test(textStr) Then
				CheckStrRegExp = True
			End If
		Case 3
			If InStr(textStr," ") Then Exit Function
			n = Len(textStr)
			If n < 3 Then Exit Function
			.Global = True
			.IgnoreCase = False
			.Pattern = Patrn
			Set Matches = .Execute(textStr)
			If Matches.Count <> n Then Exit Function
			.Pattern = Split(Patrn,"|")(0)
			Set Matches = .Execute(Mid$(textStr,2))
			If Matches.Count = 0 Then Exit Function
			CheckStrRegExp = True
		Case 4
			If StrNum < 2 Then Exit Function
			If Len(textStr) < StrNum Then Exit Function
			If InStr(textStr," ") Then Exit Function
			.Global = False
			.IgnoreCase = False
			.Pattern = "(" & Patrn & ")\1{" & StrNum - 1 & "}"
			If .Test(textStr) Then
				CheckStrRegExp = True
			End If
		End Select
	End With
End Function


'滻ضַ
'fType = 0 滻ʹõһ滻ַ
'fType = 1 ԭ滻ʹõһ滻ַ
'fType = 2 滻ʹõڶ滻ַ
'fType = 3 ԭ滻ʹõڶ滻ַ
'Record = 0 ¼滻ַ
'Record = 1 ¼滻ַ
Function ReplaceStr(ByVal CheckID As Long,ByVal trnStr As String,ByVal fType As Long,ByVal Record As Long) As String
	Dim i As Long,PreStr As String,AppStr As String
	ReplaceStr = trnStr
	PreRepStr = ""
	AppRepStr = ""
	If Trim(trnStr) = "" Then Exit Function
	'ȡѡõĲ
	TempArray = Split(CheckDataListBak(CheckID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	If fType < 2 Then AutoRepChar = SetsArray(11) Else AutoRepChar = SetsArray(12)
	If AutoRepChar <> "" Then
		FindStrArr = Split(AutoRepChar,",",-1)
		For i = 0 To UBound(FindStrArr)
			FindStr = FindStrArr(i)
			PreStr = ""
			AppStr = ""
			If InStr(FindStr,"|") Then
				TempArray = Split(FindStr,"|")
				If fType = 0 Or fType = 2 Then
					PreStr = TempArray(0)
					AppStr = TempArray(1)
				Else
					PreStr = TempArray(1)
					AppStr = TempArray(0)
				End If
				cPreStr = Convert(PreStr)
				cAppStr = Convert(AppStr)
			End If
			If PreStr <> "" And InStr(ReplaceStr,cPreStr) Then
				ReplaceStr = Replace(ReplaceStr,cPreStr,cAppStr)
				If Record = 1 Then
					If PreRepStr <> "" Then
						If InStr(PreRepStr,PreStr) = 0 Then PreRepStr = PreRepStr & JoinStr & PreStr
					Else
						PreRepStr = PreStr
					End If
					If AppRepStr <> "" Then
						If InStr(AppRepStr,AppStr) = 0 Then AppRepStr = AppRepStr & JoinStr & AppStr
					Else
						AppRepStr = AppStr
					End If
				End If
			End If
		Next i
	End If
End Function


'ݼֹͼ
Function CheckHanding(ByVal CheckID As Long,ByVal srcStr As String,ByVal trnStr As String,ByVal ProjectID As Long) As String
	Dim i As Long,srcStrBak As String,trnStrBak As String,LineSplitMode As Long
	Dim srcNum As Long,trnNum As Long,srcSplitNum As Long,trnSplitNum As Long,Stemp As Boolean
	Dim FindStr As String,srcStrArr() As String,trnStrArr() As String,TempArray() As String
	Dim k As Long,l As Long,m As Long

	'ʼ
	srcNum = 0
	trnNum = 0
	srcSplitNum = 0
	trnSplitNum = 0
	CheckHanding = trnStr
	If Trim(srcStr) = "" Or Trim(trnStr) = "" Then Exit Function

	'ȡѡõĲ
	TempArray = Split(CheckDataList(CheckID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	ExcludeChar = SetsArray(0)
	PreInsertSplitChar = SetsArray(1)
	KeepCharPair = SetsArray(3)
	AccessKeyChar = SetsArray(13)
	LineSplitMode = StrToLong(SetsArray(15))
	AppInsertSplitChar = SetsArray(16)
	ReplaceSplitChar = SetsArray(17)

	TempArray = Split(ProjectDataList(ProjectID),JoinStr)
	SetsArray = Split(TempArray(1),LngJoinStr)
	EnableStringSplit = StrToLong(SetsArray(16))

	'ò黯
	If ExcludeChar <> "" Then ExcludeCharArr = Split(ExcludeChar,",",-1)
	If KeepCharPair <> "" Then KeepCharPairArr = Split(KeepCharPair,",",-1)
	If AccessKeyChar <> "" Then AccessKeyCharArr = Split(AccessKeyChar,",",-1)

	If EnableStringSplit = 1 Then
		LineSplitChar = PreInsertSplitChar & AppInsertSplitChar & ReplaceSplitChar
		Temp = PreInsertSplitChar & "," & AppInsertSplitChar & "," & ReplaceSplitChar
		If LineSplitChar <> "" Then LineSplitCharArr = Split(Temp,",",-1)
		If PreInsertSplitChar <> "" Then k = UBound(Split(PreInsertSplitChar,",",-1)) + 1
		If AppInsertSplitChar <> "" Then l = UBound(Split(AppInsertSplitChar,",",-1)) + 1
		If ReplaceSplitChar <> "" Then m = UBound(Split(ReplaceSplitChar,",",-1)) + 1
	End If

	'ųִеķǿݼ
	If ExcludeChar <> "" Then
		For i = 0 To UBound(ExcludeCharArr)
			FindStr = LTrim(ExcludeCharArr(i))
			If FindStr <> "" Then
				srcStr = Replace(srcStr,FindStr,"*a" & i & "!N!" & i & "d*")
				trnStr = Replace(trnStr,FindStr,"*a" & i & "!N!" & i & "d*")
			End If
		Next i
	End If

	'˲ǿݼĿݼ
	If KeepCharPair <> "" Then
		For i = 0 To UBound(KeepCharPairArr)
			FindStr = Trim(KeepCharPairArr(i))
			If FindStr <> "" Then
				LFindStr = Trim(Left(FindStr,1))
				RFindStr = Trim(Right(FindStr,1))
				ToRepStr = LFindStr & "&" & RFindStr
				BeRepStr = LFindStr & "*!N!" & i & "!M!" & i & "!N!*" & RFindStr
				srcStr = Replace(srcStr,ToRepStr,BeRepStr)
				trnStr = Replace(trnStr,ToRepStr,BeRepStr)
			End If
		Next i
	End If

	'滻ִ
	If EnableStringSplit = 1 Then
		srcStrBak = srcStr
		trnStrBak = trnStr
		If LineSplitChar <> "" Then
			For i = 0 To UBound(LineSplitCharArr)
				FindStr = Trim(LineSplitCharArr(i))
				If FindStr <> "" Then
					Stemp = False
					If LineSplitMode = 1 Then
						srcNum = UBound(Split(srcStrBak,FindStr,-1))
						trnNum = UBound(Split(trnStrBak,FindStr,-1))
						If srcNum = trnNum And srcNum > 0 And trnNum > 0 Then Stemp = True
					End If
					If LineSplitMode = 0 Or Stemp = True Then
						If InStr(LCase(AccessKeyChar),LCase(FindStr)) Then
							srcStrBak = Insert(srcStrBak,FindStr,"*c!N!g*",1)
							trnStrBak = Insert(trnStrBak,FindStr,"*c!N!g*",1)
						ElseIf i < k And k <> 0 Then
							srcStrBak = Replace(srcStrBak,FindStr,"*c!N!g*" & FindStr)
							trnStrBak = Replace(trnStrBak,FindStr,"*c!N!g*" & FindStr)
						ElseIf i >= k And i < k + l + 1 And l <> 0 Then
							srcStrBak = Replace(srcStrBak,FindStr,FindStr & "*c!N!g*")
							trnStrBak = Replace(trnStrBak,FindStr,FindStr & "*c!N!g*")
						ElseIf i >= k + l And i < k + l + m + 2 And m <> 0 Then
							srcStrBak = Replace(srcStrBak,FindStr,"*c!N!g*")
							trnStrBak = Replace(trnStrBak,FindStr,"*c!N!g*")
						End If
					End If
				End If
			Next i
		End If
		srcStrArr = Split(srcStrBak,"*c!N!g*",-1)
		trnStrArr = Split(trnStrBak,"*c!N!g*",-1)

		'ִ
		Stemp = False
		srcNum = UBound(srcStrArr)
		trnNum = UBound(trnStrArr)
		If srcNum > 0 And trnNum > 0 Then
			If LineSplitMode = 0 Then Stemp = True
			If LineSplitMode = 1 And srcNum = trnNum Then Stemp = True
		End If
		If Stemp = True Then
			TempArray = MergeArray(srcStrArr,trnStrArr)
			trnStr = ReplaceStrSplit(CheckID,trnStr,TempArray,ProjectID)
		Else
			trnStr = StringReplace(CheckID,srcStr,trnStr,ProjectID)
		End If
	Else
		trnStr = StringReplace(CheckID,srcStr,trnStr,ProjectID)
	End If

	'ݼ
	srcStrBak = srcStr
	trnStrBak = trnStr
	toRepStr = Trim(AccessKeyCharArr(0))
	If AccessKeyChar <> "" Then
		For i = 0 To UBound(AccessKeyCharArr)
			FindStr = Trim(AccessKeyCharArr(i))
			If FindStr <> "" And FindStr <> toRepStr Then
				srcStrBak = Replace(srcStrBak,FindStr,toRepStr)
				trnStrBak = Replace(trnStrBak,FindStr,toRepStr)
			End If
		Next i
	End If
	StringSrc.AccKeyNum = UBound(Split(srcStrBak,toRepStr,-1))
	StringTrn.AccKeyNum = UBound(Split(trnStrBak,toRepStr,-1))

	'ԭǿݼĿݼ
	If KeepCharPair <> "" Then
		For i = 0 To UBound(KeepCharPairArr)
			FindStr = Trim(KeepCharPairArr(i))
			If FindStr <> "" Then
				LFindStr = Trim(Left(FindStr,1))
				RFindStr = Trim(Right(FindStr,1))
				ToRepStr = LFindStr & "*!N!" & i & "!M!" & i & "!N!*" & RFindStr
				BeRepStr = LFindStr & "&" & RFindStr
				srcStr = Replace(srcStr,ToRepStr,BeRepStr)
				trnStr = Replace(trnStr,ToRepStr,BeRepStr)
			End If
		Next i
	End If

	'ԭִбųķǿݼ
	If ExcludeChar <> "" Then
		For i = 0 To UBound(ExcludeCharArr)
			FindStr = LTrim(ExcludeCharArr(i))
			If FindStr <> "" Then
				srcStr = Replace(srcStr,"*a" & i & "!N!" & i & "d*",FindStr)
				trnStr = Replace(trnStr,"*a" & i & "!N!" & i & "d*",FindStr)
			End If
		Next i
	End If
	CheckHanding = trnStr
End Function


'ڿݼضַԴ˲ִ
Function Insert(ByVal SplitString As String,ByVal SplitStr As String,ByVal InsStr As String,ByVal Leng As Long) As String
	Dim i As Long,j As Long
	Insert = SplitString
	If UBound(Split(SplitString,SplitStr)) < 2 Then Exit Function
	i = InStr(Insert,SplitStr)
	Do While i > Leng
		j = InStr(i + 1,Insert,SplitStr)
		If j > i Then
			SplitString = Mid(Insert,i - Leng,j - i)
			If SplitString <> "" Then
				Insert = Replace(Insert,SplitString,SplitString & InsStr)
			End If
		End If
		i = InStr(i + 1,Insert,SplitStr)
	Loop
	'PSL.Output "Insert = " & Insert       '
End Function


'ȡеÿִ滻
Function ReplaceStrSplit(ByVal CheckID As Long,ByVal trnStr As String,StrSplitArr() As String,ByVal ProjectID As Long) As String
	Dim Temp As String,i As Long,j As Long

	j = 1
	ReplaceStrSplit = trnStr
	For i = 0 To UBound(StrSplitArr) Step 2
		Temp = StringReplace(CheckID,StrSplitArr(i),StrSplitArr(i + 1),ProjectID)

		'ǰаظַ
		If StrSplitArr(i + 1) <> Temp Then
			If j = 1 Then
				ReplaceStrSplit = Replace(ReplaceStrSplit,StrSplitArr(i + 1),Temp,j,1)
			Else
				ReplaceStrSplit = Left(ReplaceStrSplit,j - 1) & Replace(ReplaceStrSplit,StrSplitArr(i + 1),Temp,j,1)
			End If
		End If
		j = j + Len(Temp)

		'ÿеݽӣϢ
		TPreSpaceSrc = TPreSpaceSrc & StringSrc.PreSpace
		TPreSpaceTrn = TPreSpaceTrn & StringTrn.PreSpace
		TacckeySrc = TacckeySrc & StringSrc.AccKey
		TacckeyTrn = TacckeyTrn & StringTrn.AccKey
		TEndStringSrc = TEndStringSrc & StringSrc.EndString
		TEndStringTrn = TEndStringTrn & StringTrn.EndString
		TShortcutSrc = TShortcutSrc & StringSrc.Shortcut
		TShortcutTrn = TShortcutTrn & StringTrn.Shortcut
		TEndSpaceSrc = TEndSpaceSrc & StringSrc.EndSpace
		TEndSpaceTrn = TEndSpaceTrn & StringTrn.EndSpace
		TSpaceTrn = TSpaceTrn & StringTrn.Spaces
		TExpStringTrn = TExpStringTrn & StringTrn.ExpString
		TPreStringTrn = TPreStringTrn & StringTrn.PreString
		TMoveAcckey = TMoveAcckey & MoveAcckey
	Next i

	'ΪϢԭб滻Ӻ
	StringSrc.PreSpace = TPreSpaceSrc
	StringTrn.PreSpace = TPreSpaceTrn
	StringSrc.AccKey = TacckeySrc
	StringTrn.AccKey = TacckeyTrn
	StringSrc.EndString = TEndStringSrc
	StringTrn.EndString = TEndStringTrn
	StringSrc.Shortcut = TShortcutSrc
	StringTrn.Shortcut = TShortcutTrn
	StringSrc.EndSpace = TEndSpaceSrc
	StringTrn.EndSpace = TEndSpaceTrn
	StringTrn.Spaces = TSpaceTrn
	StringTrn.ExpString = TExpStringTrn
	StringTrn.PreString = TPreStringTrn
	MoveAcckey = TMoveAcckey
End Function


'лȡִĸֶβ滻ַ
Function StringReplace(ByVal CheckID As Long,ByVal srcStr As String,ByVal trnStr As String,ByVal ProjectID As Long) As String
	Dim i As Long,j As Long,x As Long,y As Long,m As Long,n As Long
	Dim AsiaKey As Long,AddAccessKeyWithFirstChar As Long,LeadingSpaceInSource As Long
	Dim LeadingSpaceInTarget As Long,LeadingSpaceInBoth As Long,TrailingSpaceInSource As Long
	Dim TrailingSpaceInTarget As Long,TrailingSpaceInBoth As Long,AccessKeyInSource As Long
	Dim AccessKeyInTarget As Long,AccessKeyInBoth As Long,EndCharInSource As Long,EndCharInTarget As Long
	Dim EndCharInBoth As Long,ShortcutInSource As Long,ShortcutInTarget As Long,ShortcutInBoth As Long
	Dim DeleteExtraSpace As Long,TranslateEndChar As Long,AccKeyInShort As Long,TempArray() As String
	Dim FindStr As String,LastStringTrn As String,Temp As String,TempBak As String,Stemp As Boolean

	'ʼ
	StringSrc.Length = 0
	StringTrn.Length = 0
	StringSrc.PreSpace = ""
	StringTrn.PreSpace = ""
	StringSrc.EndSpace = ""
	StringTrn.EndSpace = ""
	StringSrc.AccKey = ""
	StringTrn.AccKey = ""
	StringSrc.AccKeyIFR = ""
	StringTrn.AccKeyIFR = ""
	StringSrc.AccKeyKey = ""
	StringTrn.AccKeyKey = ""
	StringSrc.AccKeyPos = 0
	StringTrn.AccKeyPos = 0
	StringSrc.EndString = ""
	StringTrn.EndString = ""
	StringSrc.Shortcut = ""
	StringTrn.Shortcut = ""
	StringTrn.Spaces = ""
	StringTrn.ExpString = ""
	StringTrn.PreString = ""
	LastStringTrn = ""
	MoveAcckey = ""
	StringReplace = trnStr
	If Trim(srcStr) = "" Or Trim(trnStr) = "" Then Exit Function

	'ȡѡõĲ
	TempArray = Split(CheckDataList(CheckID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	CheckBracket = SetsArray(2)
	AsiaKey = StrToLong(SetsArray(4))
	CheckEndChar = SetsArray(5)
	NoTrnEndChar = SetsArray(6)
	AutoTrnEndChar = SetsArray(7)
	CheckShortChar = SetsArray(8)
	CheckShortKey = SetsArray(9)
	KeepShortKey = SetsArray(10)
	AccessKeyChar = SetsArray(13)
	AddAccessKeyWithFirstChar = StrToLong(SetsArray(14))

	TempArray = Split(ProjectDataList(ProjectID),JoinStr)
	SetsArray = Split(TempArray(1),LngJoinStr)
	LeadingSpaceInSource = StrToLong(SetsArray(0))
	LeadingSpaceInTarget = StrToLong(SetsArray(1))
	LeadingSpaceInBoth = StrToLong(SetsArray(2))
	TrailingSpaceInSource = StrToLong(SetsArray(3))
	TrailingSpaceInTarget = StrToLong(SetsArray(4))
	TrailingSpaceInBoth = StrToLong(SetsArray(5))
	AccessKeyInSource = StrToLong(SetsArray(6))
	AccessKeyInTarget = StrToLong(SetsArray(7))
	AccessKeyInBoth = StrToLong(SetsArray(8))
	EndCharInSource = StrToLong(SetsArray(9))
	EndCharInTarget = StrToLong(SetsArray(10))
	EndCharInBoth = StrToLong(SetsArray(11))
	ShortcutInSource = StrToLong(SetsArray(12))
	ShortcutInTarget = StrToLong(SetsArray(13))
	ShortcutInBoth = StrToLong(SetsArray(14))
	DeleteExtraSpace = StrToLong(SetsArray(15))
	TranslateEndChar = StrToLong(SetsArray(17))
	AccKeyInShort = StrToLong(SetsArray(18))

	'ò黯
	If CheckBracket <> "" Then CheckBracketArr = Split(CheckBracket,",",-1)
	If CheckEndChar <> "" Then CheckEndCharArr = Split(CheckEndChar," ",-1)
	If AutoTrnEndChar <> "" Then AutoTrnEndCharArr = Split(AutoTrnEndChar," ",-1)
	If CheckShortChar <> "" Then CheckShortCharArr = Split(CheckShortChar,",",-1)
	If AccessKeyChar <> "" Then AccessKeyCharArr = Split(AccessKeyChar,",",-1)

	'ȡԴͷĳ
	StringSrc.Length = Len(srcStr)
	StringTrn.Length = Len(trnStr)

	'ȡԴͷǰÿո
	StringSrc.PreSpace = Space(StringSrc.Length - Len(LTrim(srcStr)))
	StringTrn.PreSpace = Space(StringTrn.Length - Len(LTrim(trnStr)))

	'ȡԴͷβո
	StringSrc.EndSpace = Space(StringSrc.Length - Len(RTrim(srcStr)))
	StringTrn.EndSpace = Space(StringTrn.Length - Len(RTrim(trnStr)))

	'ȡԴͷļ
	If CheckShortChar <> "" Then
		CheckShortKey = CheckShortKey & "," & KeepShortKey
		If AccessKeyChar <> "" Then m = UBound(AccessKeyCharArr)
		For i = 0 To UBound(CheckShortCharArr)
			FindStr = Trim(CheckShortCharArr(i))
			If FindStr <> "" Then
				For n = 0 To 1
					If n = 0 Then Temp = RTrim(srcStr)
					If n = 1 Then Temp = RTrim(trnStr)
					Shortcut = ""
					ShortcutKey = ""
					If InStrRev(LTrim(Temp),FindStr) > 1 Then
						y = InStrRev(Temp,FindStr)
						ShortcutKey = Trim(Mid(Temp,y + 1))
					End If
					If ShortcutKey <> "" Then
						If AccessKeyChar <> "" Then
							For j = 0 To m
								ShortcutKey =Replace(ShortcutKey,AccessKeyCharArr(j),"")
							Next j
						End If
						If ShortcutKey = "+" Then
							If CheckKeyCode(ShortcutKey,CheckShortKey) <> 0 Then
								Shortcut = Mid(Temp,y)
							End If
						ElseIf InStr(ShortcutKey,"+") Then
							x = 0
							TempArray = Split(ShortcutKey,"+",-1)
							For j = 0 To UBound(TempArray)
								x = x + CheckKeyCode(TempArray(j),CheckShortKey)
							Next j
							If x > 0 And x >= UBound(TempArray) Then
								Shortcut = Mid(Temp,y)
							End If
						Else
							If CheckKeyCode(ShortcutKey,CheckShortKey) <> 0 Then
								Shortcut = Mid(Temp,y)
							End If
						End If
						If Shortcut <> "" Then
							If n = 0 And StringSrc.Shortcut = "" Then
								StringSrc.Shortcut = Shortcut
								ShortcutKeySrc = ShortcutKey
							ElseIf n = 1 And StringTrn.Shortcut = "" Then
								StringTrn.Shortcut = Shortcut
								ShortcutKeyTrn = ShortcutKey
							End If
						End If
					End If
				Next n
			End If
			If StringSrc.Shortcut <> "" And StringTrn.Shortcut <> "" Then Exit For
		Next i
	End If

	'ȡԴͷֹǰո
	If CheckEndChar <> "" Then
		xTemp = Left(srcStr,StringSrc.Length - Len(StringSrc.Shortcut & StringSrc.EndSpace))
		yTemp = Left(trnStr,StringTrn.Length - Len(StringTrn.Shortcut & StringTrn.EndSpace))
		If NoTrnEndChar <> "" Then
			If CheckKeyCode(xTemp,NoTrnEndChar) = 1 Then xTemp = ""
			If CheckKeyCode(yTemp,NoTrnEndChar) = 1 Then yTemp = ""
		End If
	End If
	If xTemp <> "" And yTemp <> "" Then
		If AccessKeyChar <> "" Then m = UBound(AccessKeyCharArr)
		For i = 0 To UBound(CheckEndCharArr)
			FindStr = Trim(CheckEndCharArr(i))
			If FindStr <> "" Then
				PreFindStr = Left(FindStr,1)
				AppFindStr = Right(FindStr,1)
				For j = 0 To 1
					If j = 0 Then
						Temp = xTemp
						EndSpace = StringSrc.EndSpace
						Shortcut = StringSrc.Shortcut
					Else
						Temp = yTemp
						EndSpace = StringTrn.EndSpace
						Shortcut = StringTrn.Shortcut
					End If
					n = 0
					y = InStrRev(Temp,FindStr)
					If y > 0 Then
						If Trim(Mid(Temp,y)) Like FindStr Then
							n = y
						ElseIf Right(Trim(Temp),1) = AppFindStr Then
							y = InStr(Temp,PreFindStr)
							Do While y > 0
								TempBak = Trim(Mid(Temp,y))
								If AccessKeyChar <> "" Then
									For x = 0 To m
										TempBak = Replace(TempBak,AccessKeyCharArr(x),"")
									Next x
								End If
								If TempBak Like FindStr Then
									n = y
									Exit Do
								End If
								y = InStr(y + 1,Temp,PreFindStr)
							Loop
						End If
					End If
					If n <> 0 Then
						PreStr = Left(Temp,n - 1)
						AppStr = Mid(Temp,n)
						x = Len(PreStr) - Len(RTrim(PreStr))
						If j = 0 And StringSrc.EndString = "" Then
							StringSrc.EndString = Space(x) & AppStr
						ElseIf j = 1 And StringTrn.EndString = "" Then
							StringTrn.EndString = Space(x) & AppStr
						End If
					End If
				Next j
			End If
			If StringSrc.EndString <> "" And StringTrn.EndString <> "" Then Exit For
		Next i
	End If

	'ȡԴͷĿݼλüַ
	If AccessKeyChar <> "" Then
		For i = 0 To UBound(AccessKeyCharArr)
			FindStr = Trim(AccessKeyCharArr(i))
			If FindStr <> "" Then
				For j = 0 To 1
					If j = 0 Then Temp = srcStr
					If j = 1 Then Temp = trnStr
					n = InStrRev(Temp,FindStr)
					If n > 0 Then
						If j = 0 And n > StringSrc.AccKeyPos Then
							StringSrc.AccKeyPos = n
							StringSrc.AccKeyIFR = FindStr
							StringSrc.AccKeyKey = Mid(Temp,n + Len(FindStr),1)
						ElseIf j = 1 And n > StringTrn.AccKeyPos Then
							StringTrn.AccKeyPos = n
							StringTrn.AccKeyIFR = FindStr
							StringTrn.AccKeyKey = Mid(Temp,n + Len(FindStr),1)
						End If
					End If
				Next j
			End If
		Next i
	End If
	If StringSrc.AccKeyIFR = "" Then StringSrc.AccKeyIFR = "&"
	If StringTrn.AccKeyIFR = "" Then StringTrn.AccKeyIFR = "&"

	'ȡԴͷĿݼ (ݼǰַ)
	If (StringSrc.AccKeyPos > 1 Or StringTrn.AccKeyPos > 1) And CheckBracket <> "" Then
		For i = 0 To UBound(CheckBracketArr)
			FindStr = Trim(CheckBracketArr(i))
			If FindStr <> "" Then
				PreFindStr = Trim(Left(FindStr,1))
				AppFindStr = Trim(Right(FindStr,1))
				For n = 0 To 1
					If n = 0 Then
						Temp = srcStr
						j = StringSrc.AccKeyPos
						xTemp = StringSrc.AccKeyIFR
						yTemp = StringSrc.AccKeyKey
					ElseIf n = 1 Then
						Temp = trnStr
						j = StringTrn.AccKeyPos
						xTemp = StringTrn.AccKeyIFR
						yTemp = StringTrn.AccKeyKey
					End If
					AccessKey = ""
					If j > 1 Then
						x = InStrRev(Temp,PreFindStr,j)
						y = InStr(j,Temp,AppFindStr)
						If x > 0 And y > x Then
							TempBak = Mid(Temp,x + 1,y - x - 1)
							If Trim(TempBak) = xTemp & yTemp Then
								AccessKey = Mid(Temp,x,y - x + 1)
								j = x
							End If
						End If
					ElseIf j = 1 Then
						AccessKey = xTemp
					End If
					If AccessKey <> "" Then
						If n = 0 And StringSrc.AccKey = "" Then
							StringSrc.AccKeyPos = j
							StringSrc.AccKey = AccessKey
						ElseIf n = 1 And StringTrn.AccKey = "" Then
							StringTrn.AccKeyPos = j
							StringTrn.AccKey = AccessKey
						End If
					End If
				Next n
			End If
			If StringSrc.AccKey <> "" And StringTrn.AccKey <> "" Then Exit For
		Next i
	End If
	If StringSrc.AccKey = "" And StringSrc.AccKeyPos > 0 Then StringSrc.AccKey = StringSrc.AccKeyIFR
	If StringTrn.AccKey = "" And StringTrn.AccKeyPos > 0 Then StringTrn.AccKey = StringTrn.AccKeyIFR

	'ȡĿݼķֹͷǼַ(ո)
	If StringTrn.AccKeyPos > 0 Then
		x = Len(StringTrn.EndString & StringTrn.Shortcut & StringTrn.EndSpace)
		'If InStr(StringTrn.Shortcut,StringTrn.AcckeyIFR) Then x = Len(StringTrn.EndSpace)
		'If InStr(StringTrn.EndString,StringTrn.AcckeyIFR) Then x = Len(StringTrn.Shortcut & StringTrn.EndSpace)
		If StringTrn.Length > x Then
			Temp = Left(trnStr,StringTrn.Length - x)
			StringTrn.ExpString = Mid(Temp,StringTrn.AccKeyPos + Len(StringTrn.AccKey))
		End If
	End If

	'ȡĿݼֹǰĿո
	Temp = StringTrn.AccKey & StringTrn.ExpString & StringTrn.EndString & _
			StringTrn.Shortcut & StringTrn.EndSpace
	If Temp <> "" Then
		x = Len(Temp)
		If InStr(StringTrn.EndString & StringTrn.Shortcut,StringTrn.AccKeyIFR) Then
			x = Len(StringTrn.EndString & StringTrn.Shortcut & StringTrn.EndSpace)
		End If
		If StringTrn.Length > x Then
			Temp = Left(trnStr,StringTrn.Length - x)
			y = Len(Temp) - Len(RTrim(Temp))
			If y > 0 Then StringTrn.Spaces = Space(y)
		End If
	End If

	'ȡĿݼǰֹֹǰĿո
	If StringTrn.AccKey <> "" And CheckEndChar <> "" Then
		x = Len(StringTrn.Spaces & StringTrn.AccKey & StringTrn.ExpString & StringTrn.EndString & _
			StringTrn.Shortcut & StringTrn.EndSpace)
		If InStr(StringTrn.EndString & StringTrn.Shortcut,StringTrn.AccKeyIFR) Then
			x = Len(StringTrn.Spaces & StringTrn.EndString & StringTrn.Shortcut & StringTrn.EndSpace)
		End If
		Temp = Left(trnStr,StringTrn.Length - x)
		If Trim(Temp) <> "" Then
			If NoTrnEndChar <> "" Then
				If CheckKeyCode(Temp,NoTrnEndChar) = 1 Then Temp = ""
			End If
			If Temp <> "" Then
				For i = 0 To UBound(CheckEndCharArr)
					FindStr = Trim(CheckEndCharArr(i))
					PreFindStr = Left(FindStr,1)
					AppFindStr = Right(FindStr,1)
					n = 0
					y = InStrRev(Temp,FindStr)
					If y > 0 Then
						If Trim(Mid(Temp,y)) Like FindStr Then
							n = y
						ElseIf Right(Trim(Temp),1) = AppFindStr Then
							y = InStr(Temp,PreFindStr)
							Do While y > 0
								TempBak = Trim(Mid(Temp,y))
								If TempBak Like FindStr Then
									n = y
									Exit Do
								End If
								y = InStr(y + 1,Temp,PreFindStr)
							Loop
						End If
					End If
					If n > 0 Then
						PreStr = Left(Temp,n - 1)
						AppStr = Mid(Temp,n)
						x = Len(PreStr) - Len(RTrim(PreStr))
						StringTrn.PreString = Space(x) & AppStr
					End If
					If StringTrn.PreString <> "" Then Exit For
				Next i
			End If
		End If
	End If

	'ȡгȡַַ
	Temp = StringTrn.PreString & StringTrn.Spaces & StringTrn.AccKey & StringTrn.ExpString & _
			StringTrn.EndString & StringTrn.Shortcut & StringTrn.EndSpace
	If Temp <> "" Then
		x = Len(Temp)
		If InStr(StringTrn.EndString & StringTrn.Shortcut,StringTrn.AccKeyIFR) Then
			x = Len(StringTrn.PreString & StringTrn.Spaces & StringTrn.EndString & _
				StringTrn.Shortcut & StringTrn.EndSpace)
		End If
		Temp = LTrim(trnStr)
		y = Len(Temp)
		If y > x Then LastStringTrn = Left(Temp,y - x)
	Else
		LastStringTrn = Trim(trnStr)
	End If

	'ļ
	If StringSrc.Shortcut <> "" And StringTrn.Shortcut <> "" And KeepShortKey <> "" Then
		SrcKeyArr = Split(ShortcutKeySrc,"+",-1)
		x = UBound(SrcKeyArr)
		TrnKeyArr = Split(ShortcutKeyTrn,"+",-1)
		y = UBound(TrnKeyArr)
		If x = y Then
			For i = 0 To x
				Temp = Trim(SrcKeyArr(i))
				TempBak = Trim(TrnKeyArr(i))
				If Temp <> "" And TempBak <> "" Then
					If CheckKeyCode(TempBak,KeepShortKey) <> 0 Then
						StringSrc.Shortcut = Replace(StringSrc.Shortcut,Temp,TempBak)
					End If
				End If
			Next i
		End If
	End If

	'PSL.Output "------------------------------ "   		'
	'PSL.Output "srcStr = " & srcStr                		'
	'PSL.Output "trnStr = " & trnStr               			'
	'PSL.Output "SpaceTrn = " & StringTrn.Spaces            '
	'PSL.Output "KeySrc = " & StringTrnKeySrc               '
	'PSL.Output "acckeySrc = " & StringSrc.AccKey          	'
	'PSL.Output "acckeyTrn = " & StringTrn.AccKey         	'
	'PSL.Output "EndStringSrc = " & StringSrc.EndString   	'
	'PSL.Output "EndStringTrn = " & StringTrn.EndString   	'
	'PSL.Output "ShortcutSrc = " & StringSrc.Shortcut     	'
	'PSL.Output "ShortcutTrn = " & StringTrn.Shortcut     	'
	'PSL.Output "ExpStringTrn = " & StringTrn.ExpString   	'
	'PSL.Output "PreStringTrn = " & StringTrn.PreString   	'
	'PSL.Output "LastStringTrn = " & LastStringTrn  		'
	'PSL.Output "MoveAcckey = " & MoveAcckey                '

	'ݲֵ
	SpaceTrnBak = StringTrn.Spaces
	ExpStringTrnBak = StringTrn.ExpString
	PreStringTrnBak = StringTrn.PreString
	ShortcutSrcBak = StringSrc.Shortcut
	EndStringSrcBak = StringTrn.EndString

	'ִѡ
	If AllCont <> 1 Then
		If Acceler <> 1 Then
			ShortcutInSource = 0
			ShortcutInTarget = 0
			ShortcutInBoth = 0
		End If
		If EndChar <> 1 Then
			EndCharInSource = 0
			EndCharInTarget = 0
			EndCharInBoth = 0
			TranslateEndChar = 0
		End If
		If AccKey <> 1 Then
			AccessKeyInSource = 0
			AccessKeyInTarget = 0
			AccessKeyInBoth = 0
			If AsiaKey = 1 Then
				If StringTrn.AccKey = StringTrn.AccKeyIFR Then AsiaKey = 0
			Else
				If StringTrn.AccKey <> StringTrn.AccKeyIFR Then AsiaKey = 1
			End If
		End If
	End If

	'ݼ
	If ProjectID >= 0 Then
		'ִм
		If StringSrc.PreSpace <> "" And StringTrn.PreSpace = "" Then
			If LeadingSpaceInSource = 0 Then StringSrc.PreSpace = StringTrn.PreSpace
		ElseIf StringSrc.PreSpace = "" And StringTrn.PreSpace <> "" Then
			If LeadingSpaceInTarget = 0 Then StringSrc.PreSpace = StringTrn.PreSpace
		ElseIf StringSrc.PreSpace <> "" And StringTrn.PreSpace <> "" Then
			If LeadingSpaceInBoth = 0 Then StringSrc.PreSpace = StringTrn.PreSpace
			If LeadingSpaceInBoth = 2 Then StringSrc.PreSpace = ""
		End If
		If StringSrc.EndSpace <> "" And StringTrn.EndSpace = "" Then
			If LeadingSpaceInSource = 0 Then StringSrc.EndSpace = StringTrn.EndSpace
		ElseIf StringSrc.EndSpace = "" And StringTrn.EndSpace <> "" Then
			If TrailingSpaceInTarget = 0 Then StringSrc.EndSpace = StringTrn.EndSpace
		ElseIf StringSrc.EndSpace <> "" And StringTrn.EndSpace <> "" Then
			If TrailingSpaceInBoth = 0 Then StringSrc.EndSpace = StringTrn.EndSpace
			If TrailingSpaceInBoth = 2 Then StringSrc.EndSpace = ""
		End If
		If StringSrc.AccKey <> "" And StringTrn.AccKey = "" Then
			If AccessKeyInSource = 0 Then
				StringSrc.AccKey = StringTrn.AccKey
				StringSrc.AccKeyIFR = StringTrn.AccKeyIFR
				StringSrc.AccKeyKey = StringTrn.AccKeyKey
			End If
		ElseIf StringSrc.AccKey = "" And StringTrn.AccKey <> "" Then
			If AccessKeyInTarget = 0 Then
				StringSrc.AccKey = StringTrn.AccKey
				StringSrc.AccKeyIFR = StringTrn.AccKeyIFR
				StringSrc.AccKeyKey = StringTrn.AccKeyKey
			End If
		ElseIf StringSrc.AccKey <> "" And StringTrn.AccKey <> "" Then
			If AccessKeyInBoth = 0 Then
				StringSrc.AccKey = StringTrn.AccKey
				StringSrc.AccKeyIFR = StringTrn.AccKeyIFR
				StringSrc.AccKeyKey = StringTrn.AccKeyKey
			ElseIf AccessKeyInBoth = 2 Then
				StringSrc.AccKey = ""
			End If
		End If
		If StringSrc.EndString <> "" And StringTrn.EndString = "" Then
			If EndCharInSource = 0 Then StringSrc.EndString = StringTrn.EndString
		ElseIf StringSrc.EndString = "" And StringTrn.EndString <> "" Then
			If EndCharInTarget = 0 Then StringSrc.EndString = StringTrn.EndString
		ElseIf StringSrc.EndString <> "" And StringTrn.EndString <> "" Then
			If EndCharInBoth = 0 Then StringSrc.EndString = StringTrn.EndString
			If EndCharInBoth = 2 Then StringSrc.EndString = ""
		End If
		If StringSrc.Shortcut <> "" And StringTrn.Shortcut = "" Then
			If ShortcutInSource = 0 Then StringSrc.Shortcut = StringTrn.Shortcut
		ElseIf StringSrc.Shortcut = "" And StringTrn.Shortcut <> "" Then
			If ShortcutInTarget = 0 Then StringSrc.Shortcut = StringTrn.Shortcut
		ElseIf StringSrc.Shortcut <> "" And StringTrn.Shortcut <> "" Then
			If ShortcutInBoth = 0 Then StringSrc.Shortcut = StringTrn.Shortcut
			If ShortcutInBoth = 2 Then StringSrc.Shortcut = ""
		End If

		'ÿݼʽ
		If InStr(StringTrn.EndString & StringTrn.Shortcut,StringTrn.AccKeyIFR) Then
			StringTrn.ExpString = ""
			If AsiaKey = 0 Then StringTrn.PreString = ""
		End If
		If StringTrn.AccKey = StringTrn.AccKeyIFR Then
			StringTrn.AccKey = StringTrn.AccKeyIFR & StringTrn.AccKeyKey
		End If
		If StringSrc.AccKey <> "" Then
			If AsiaKey = 0 Then
				StringSrc.AccKey = StringSrc.AccKeyIFR & StringSrc.AccKeyKey
				KeySrc = StringSrc.AccKeyIFR
			Else
				StringSrc.AccKey = "(" & StringSrc.AccKeyIFR & UCase(StringSrc.AccKeyKey) & ")"
				KeySrc = StringSrc.AccKey
			End If
		End If

		'ȷݼǷƶ
		Stemp = False
		If StringSrc.AccKey <> "" Then
			i = InStr(StringSrc.Shortcut,StringSrc.AccKeyIFR)
			j = InStr(StringTrn.Shortcut,StringTrn.AccKeyIFR)
			x = InStr(StringSrc.EndString,StringSrc.AcckeyIFR)
			y = InStr(StringTrn.EndString,StringTrn.AcckeyIFR)
			If LCase(StringSrc.AccKey) = LCase(StringTrn.AccKey) Then
				If AccKeyInShort = 1 Then
					If i > 0 And j = 0 Then MoveAcckey = "ShortcutSrc"
					If x > 0 And y = 0 Then MoveAcckey = "EndStringSrc"
					If i = 0 And j > 0 Then MoveAcckey = "ShortcutTrn"
					If x = 0 And y > 0 Then MoveAcckey = "EndStringTrn"
				Else
					If j > 0 Then MoveAcckey = "ShortcutTrn"
					If y > 0 Then MoveAcckey = "EndStringTrn"
				End If
			Else
				i = InStr(ShortcutSrcBak,StringSrc.AccKeyIFR)
				x = InStr(EndStringSrcBak,StringSrc.AccKeyIFR)
				If i = 0 And j > 0 Then Stemp = True
				If x = 0 And y > 0 Then Stemp = True
			End If
		End If

		'ƶɾݼǰֹ
		If StringTrn.PreString <> "" And AsiaKey = 1 Then
			If StringSrc.EndString & StringTrn.EndString = "" Then
				StringSrc.EndString = StringTrn.PreString
			End If
			StringTrn.PreString = ""
		End If

		'ɾжո
		If DeleteExtraSpace = 1 Then
			If StringTrn.Spaces <> "" Then
				If AsiaKey = 0 Then
					If Len(StringTrn.Spaces) > 1 Then StringTrn.Spaces = Space(1)
				Else
					StringTrn.Spaces = ""
				End If
			End If
			If StringTrn.PreString <> "" Then StringTrn.PreString = Trim(StringTrn.PreString)
			If StringTrn.ExpString <> "" Then StringTrn.ExpString = Trim(StringTrn.ExpString)
			If StringSrc.Shortcut <> "" Then StringSrc.Shortcut = Trim(StringSrc.Shortcut)
			If StringSrc.EndString <> "" Then
				If StringSrc.EndString = Space(1) & LTrim(StringSrc.EndString) Then
					StringSrc.EndString = RTrim(StringSrc.EndString)
				Else
					StringSrc.EndString = Trim(StringSrc.EndString)
				End If
			End If
		End If

		'ȷݼķʽ
		If StringSrc.AccKey <> "" And AccKeyInShort = 1 Then
			If InStr(StringSrc.EndString & StringSrc.Shortcut,StringSrc.AccKeyIFR) Then
				If Stemp = False Then
					StringSrc.AccKey = StringSrc.AccKeyIFR & StringSrc.AccKeyKey
					KeySrc = ""
				End If
			End If
		End If
		If StringSrc.AccKey = "" Or KeySrc <> "" Then
			If InStr(StringSrc.Shortcut,StringSrc.AccKeyIFR) Then
				StringSrc.Shortcut = Replace(StringSrc.Shortcut,StringSrc.AccKeyIFR,"")
			End If
			If InStr(StringSrc.EndString,StringSrc.AccKeyIFR) Then
				StringSrc.EndString = Replace(StringSrc.EndString,StringSrc.AccKeyIFR,"")
			End If
		End If

		'Զֹ
		If StringSrc.EndString <> "" And TranslateEndChar = 1 And AutoTrnEndChar <> "" Then
			Temp = Replace(Trim(StringSrc.EndString),StringSrc.AccKeyIFR,"")
			If Trim(Temp) <> "" Then
				For i = 0 To UBound(AutoTrnEndCharArr)
					FindStr = Trim(AutoTrnEndCharArr(i))
					If InStr(FindStr,"|") Then
						TempArray = Split(FindStr,"|")
						If Temp = TempArray(0) Then
							StringSrc.EndString = Replace(StringSrc.EndString,Temp,TempArray(1))
							Exit For
						End If
					End If
				Next i
			End If
		End If

		'ҿݼַÿݼ
		If StringSrc.AccKey <> "" And KeySrc <> "" And AsiaKey = 0 Then
			If LCase(StringSrc.AccKey) <> LCase(StringTrn.AccKey) Or MoveAcckey <> "" Then
				For i = 0 To 3
					Temp = ""
					If AccKeyInShort = 0 Then
						If i = 0 Then Temp = LastStringTrn
						If i = 1 Then Temp = StringTrn.ExpString
					Else
						If i = 0 Then Temp = LastStringTrn
						If i = 1 Then Temp = StringTrn.ExpString
						If i = 2 Then Temp = StringSrc.Shortcut
						If i = 3 Then Temp = StringSrc.EndString
					End If
					If Trim(Temp) <> "" Then
						StringTrn.AccKeyPos = InStr(Temp,StringSrc.AccKeyKey)
						If StringTrn.AccKeyPos = 0 Then
							StringTrn.AccKeyPos = InStr(LCase(Temp),LCase(StringSrc.AccKeyKey))
						End If
						If StringTrn.AccKeyPos > 0 Then
							StringTrn.AccKeyKey = Mid(Temp,StringTrn.AccKeyPos,1)
							Temp = Replace(Temp,StringTrn.AccKeyKey,StringSrc.AccKeyIFR & StringTrn.AccKeyKey,,1)
							StringSrc.AccKey = StringSrc.AccKeyIFR & StringTrn.AccKeyKey
							KeySrc = ""
						End If
					End If
					If AccKeyInShort = 0 Then
						If i = 0 Then LastStringTrn = Temp
						If i = 1 Then StringTrn.ExpString = Temp
					Else
						If i = 0 Then LastStringTrn = Temp
						If i = 1 Then StringTrn.ExpString = Temp
						If i = 2 Then StringSrc.Shortcut = Temp
						If i = 3 Then StringSrc.EndString = Temp
					End If
					If KeySrc = "" Then Exit For
				Next i
				If KeySrc <> "" Then
					If AddAccessKeyWithFirstChar = 1 Then
						i = 0
						If Trim(LastStringTrn) <> "" Then
							CheckStrRegExp(LastStringTrn,CheckSkipStr(5),0,i)
							If i = 0 Then
								i = Len(LastStringTrn) - Len(LTrim(LastStringTrn)) + 1
							End If
							If i > 0 Then
								PreTrn = Left(LastStringTrn,i - 1)
								AppTrn = Mid(LastStringTrn,i)
								StringTrn.AccKeyKey = Mid(LastStringTrn,i,1)
								LastStringTrn = PreTrn & StringSrc.AccKeyIFR & AppTrn
								StringSrc.AccKey = StringSrc.AccKeyIFR & StringTrn.AccKeyKey
							Else
								StringSrc.AccKey = ""
							End If
							MoveAcckey = ""
							KeySrc = ""
						ElseIf Trim(StringTrn.ExpString) <> "" Then
							CheckStrRegExp(StringTrn.ExpString,CheckSkipStr(5),0,i)
							If i = 0 Then
								i = Len(StringTrn.ExpString) - Len(LTrim(StringTrn.ExpString)) + 1
							End If
							If i > 0 Then
								PreTrn = Left(StringTrn.ExpString,i - 1)
								AppTrn = Mid(StringTrn.ExpString,i)
								StringTrn.AccKeyKey = Mid(StringTrn.ExpString,i,1)
								StringTrn.ExpString = PreTrn & StringSrc.AccKeyIFR & AppTrn
								StringSrc.AccKey = StringSrc.AccKeyIFR & StringTrn.AccKeyKey
							Else
								StringSrc.AccKey = ""
							End If
							MoveAcckey = ""
							KeySrc = ""
						End If
					Else
						MoveAcckey = ""
						StringSrc.AccKey = ""
						KeySrc = ""
					End If
				End If
			Else
				StringTrn.AccKey = StringSrc.AccKey
			End If
		End If

		'֯滻ַ
		If AsiaKey = 0 Then
			NewStringTrn = StringSrc.PreSpace & LastStringTrn & StringTrn.PreString & StringTrn.Spaces & KeySrc & _
							StringTrn.ExpString & StringSrc.EndString & StringSrc.Shortcut & StringSrc.EndSpace
		Else
			NewStringTrn = StringSrc.PreSpace & LastStringTrn & StringTrn.PreString & StringTrn.Spaces & _
							StringTrn.ExpString & KeySrc & StringSrc.EndString & StringSrc.Shortcut & StringSrc.EndSpace
		End If

		'ִ滻
		If StringReplace <> NewStringTrn Then StringReplace = NewStringTrn
	End If

	'ԭ
	StringTrn.Spaces = SpaceTrnBak
	StringTrn.ExpString = ExpStringTrnBak
	StringTrn.PreString = PreStringTrnBak

	'ɾֹͼеĿݼԱȷȽֹͼ
	If InStr(StringSrc.Shortcut,StringSrc.AccKeyIFR) Then StringSrc.Shortcut = Replace(StringSrc.Shortcut,StringSrc.AccKeyIFR,"")
	If InStr(StringSrc.Shortcut,StringTrn.AccKeyIFR) Then StringSrc.Shortcut = Replace(StringSrc.Shortcut,StringTrn.AccKeyIFR,"")
	If InStr(StringTrn.Shortcut,StringSrc.AccKeyIFR) Then StringTrn.Shortcut = Replace(StringTrn.Shortcut,StringSrc.AcckeyIFR,"")
	If InStr(StringTrn.Shortcut,StringTrn.AccKeyIFR) Then StringTrn.Shortcut = Replace(StringTrn.Shortcut,StringTrn.AccKeyIFR,"")
	If InStr(StringSrc.EndString,StringSrc.AccKeyIFR) Then StringSrc.EndString = Replace(StringSrc.EndString,StringSrc.AccKeyIFR,"")
	If InStr(StringSrc.EndString,StringTrn.AccKeyIFR) Then StringSrc.EndString = Replace(StringSrc.EndString,StringTrn.AccKeyIFR,"")
	If InStr(StringTrn.EndString,acckeyIFRSrc) Then StringTrn.EndString = Replace(StringTrn.EndString,StringSrc.AccKeyIFR,"")
	If InStr(StringTrn.EndString,acckeyIFRTrn) Then StringTrn.EndString = Replace(StringTrn.EndString,StringTrn.AccKeyIFR,"")
	If InStr(MoveAcckey,StringSrc.AccKeyIFR) Then MoveAcckey = Replace(MoveAcckey,StringSrc.AccKeyIFR,"")
	If InStr(MoveAcckey,StringTrn.AccKeyIFR) Then MoveAcckey = Replace(MoveAcckey,StringTrn.AccKeyIFR,"")
End Function


' ޸Ϣ
Function ReplaceMassage(ByVal CheckID As Long,ByVal ProjectID As Long) As String
	Dim i As Long,j As Long,m As Long,a As Long,v As Long,d As Long,r As Long
	Dim ModifiedMsg() As String,AddedMsg() As String,MovedMsg() As String
	Dim DeledMsg() As String,ReplacedMsg() As String,Massage() As String
	Dim sL As Long,tL As Long,sR As Long,tR As Long,MsgList() As String
	Dim AsiaKey As Long,DeleteExtraSpace As Long

	If getMsgList(UIDataList,MsgList,"ReplaceMassage",1) = False Then Exit Function

	'ȡѡõĲ
	TempArray = Split(CheckDataList(CheckID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	AsiaKey = StrToLong(SetsArray(4))

	TempArray = Split(ProjectDataList(ProjectID),JoinStr)
	SetsArray = Split(TempArray(1),LngJoinStr)
	DeleteExtraSpace = StrToLong(SetsArray(15))
	If StrToLong(SetsArray(20)) = 0 Then
		For i = 23 To 27
			MsgList(i) = MsgList(i + 8)
		Next i
	End If

	'ʼ
	ReDim ModifiedMsg(m),AddedMsg(a),MovedMsg(v),DeledMsg(d),ReplacedMsg(r),Massage(0)

	'ݼ
	If StringSrc.AccKey <> StringTrn.AccKey Then
		If StringSrc.AccKey <> "" And StringTrn.AccKey <> "" Then
			ModifiedMsg(m) = MsgList(0)
		ElseIf StringSrc.AccKey <> "" And StringTrn.AccKey = "" Then
			AddedMsg(a) = MsgList(0)
		ElseIf StringSrc.AccKey = "" And StringTrn.AccKey <> "" Then
			DeledMsg(d) = MsgList(0)
		ElseIf LCase(StringSrc.AccKey) = LCase(StringTrn.AccKey) Then
			ModifiedMsg(m) = MsgList(1)
		End If
		If ModifiedMsg(m) <> "" Then m = m + 1
		If AddedMsg(a) <> "" Then a = a + 1
		If DeledMsg(d) <> "" Then d = d + 1
	End If

	'ֹ
	If StringSrc.EndString <> StringTrn.EndString Then
		If StringSrc.EndString <> "" And StringTrn.EndString <> "" Then
			If Trim(StringSrc.EndString) <> Trim(StringTrn.EndString) Then
				ReDim Preserve ModifiedMsg(m)
				ModifiedMsg(m) = MsgList(2)
				m = m + 1
			End If
		ElseIf StringSrc.EndString <> "" And StringTrn.EndString = "" Then
			If Trim(StringSrc.EndString) <> Trim(PreStringTrn) Then
				ReDim Preserve AddedMsg(a)
				AddedMsg(a) = MsgList(2)
				a = a + 1
			End If
		ElseIf StringSrc.EndString = "" And StringTrn.EndString <> "" Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(2)
			d = d + 1
		End If
	End If

	'
	If StringSrc.Shortcut <> StringTrn.Shortcut Then
		If StringSrc.Shortcut <> "" And StringTrn.Shortcut <> "" Then
			ReDim Preserve ModifiedMsg(m)
			ModifiedMsg(m) = MsgList(3)
			m = m + 1
		ElseIf StringSrc.Shortcut <> "" And StringTrn.Shortcut = "" Then
			ReDim Preserve AddedMsg(a)
			AddedMsg(a) = MsgList(3)
			a = a + 1
		ElseIf StringSrc.Shortcut = "" And StringTrn.Shortcut <> "" Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(3)
			d = d + 1
		End If
	End If

	'ǰÿո
	If StringSrc.PreSpace <> StringTrn.PreSpace Then
		If StringSrc.PreSpace <> "" And StringTrn.PreSpace <> "" Then
			ReDim Preserve ModifiedMsg(m)
			ModifiedMsg(m) = MsgList(4)
			m = m + 1
		ElseIf StringSrc.PreSpace <> "" And StringTrn.PreSpace = "" Then
			ReDim Preserve AddedMsg(a)
			AddedMsg(a) = MsgList(4)
			a = a + 1
		ElseIf StringSrc.PreSpace = "" And StringTrn.PreSpace <> "" Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(4)
			d = d + 1
		End If
	End If

	'ÿո
	If StringSrc.EndSpace <> StringTrn.EndSpace Then
		If StringSrc.EndSpace <> "" And StringTrn.EndSpace <> "" Then
			ReDim Preserve ModifiedMsg(m)
			ModifiedMsg(m) = MsgList(5)
			m = m + 1
		ElseIf StringSrc.EndSpace <> "" And StringTrn.EndSpace = "" Then
			ReDim Preserve AddedMsg(a)
			AddedMsg(a) = MsgList(5)
			a = a + 1
		ElseIf StringSrc.EndSpace = "" And StringTrn.EndSpace <> "" Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(5)
			d = d + 1
		End If
	End If

	'ݼֹǰĿո
	If DeleteExtraSpace = 1 Then
		If StringTrn.Spaces <> "" And StringTrn.ExpString = "" Then
			ReDim Preserve DeledMsg(d)
			If StringSrc.Shortcut <> "" Or StringTrn.Shortcut <> "" Then DeledMsg(d) = MsgList(6)
			If StringSrc.EndString <> "" Or StringTrn.EndString <> "" Then DeledMsg(d) = MsgList(7)
			If StringSrc.AccKey <> "" Or StringTrn.AccKey <> "" Then DeledMsg(d) = MsgList(10)
			If DeledMsg(d) <> "" Then d = d + 1
		ElseIf StringTrn.Spaces <> "" And StringTrn.ExpString <> "" Then
			i = Len(StringTrn.ExpString) - Len(LTrim(StringTrn.ExpString))
			j = Len(StringTrn.ExpString) - Len(RTrim(StringTrn.ExpString))
			ReDim Preserve DeledMsg(d)
			If i = 0 Then DeledMsg(d) = MsgList(10) Else DeledMsg(d) = MsgList(12)
			d = d + 1
			If Trim(StringTrn.ExpString) <> "" And j > 0 Then
				ReDim Preserve DeledMsg(d)
				If StringTrn.Shortcut <> "" Then DeledMsg(d) = MsgList(6)
				If StringTrn.EndString <> "" Then DeledMsg(d) = MsgList(7)
				If DeledMsg(d) <> "" Then d = d + 1
			End If
		ElseIf StringTrn.Spaces = "" And StringTrn.ExpString <> "" Then
			i = Len(StringTrn.ExpString) - Len(LTrim(StringTrn.ExpString))
			j = Len(StringTrn.ExpString) - Len(RTrim(StringTrn.ExpString))
			If i > 0 Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(11)
				d = d + 1
			End If
			If Trim(StringTrn.ExpString) <> "" And j > 0 Then
				ReDim Preserve DeledMsg(d)
				If StringTrn.Shortcut <> "" Then DeledMsg(d) = MsgList(6)
				If StringTrn.EndString <> "" Then DeledMsg(d) = MsgList(7)
				If DeledMsg(d) <> "" Then d = d + 1
			End If
		End If
		If StringTrn.PreString <> "" And StringTrn.PreString <> LTrim(StringTrn.PreString) Then
			ReDim Preserve DeledMsg(d)
			DeledMsg(d) = MsgList(13)
			d = d + 1
		End If

		'ֹǰĿո
		If StringSrc.EndString <> StringTrn.EndString Then
			If StringSrc.EndString <> "" And StringTrn.EndString <> "" Then
				sL = Len(StringSrc.EndString) - Len(LTrim(StringSrc.EndString))
				tL = Len(StringTrn.EndString) - Len(LTrim(StringTrn.EndString))
				sR = Len(StringSrc.EndString) - Len(RTrim(StringSrc.EndString))
				tR = Len(StringTrn.EndString) - Len(RTrim(StringTrn.EndString))
				i = sL - tL
				j = sR - tR
				If i > 0 Or j > 0 Then
					ReDim Preserve AddedMsg(a)
					If i > 0 And j = 0 Then
						AddedMsg(a) = MsgList(7)
					ElseIf i = 0 And j > 0 Then
						AddedMsg(a) = MsgList(8)
					ElseIf i > 0 And j > 0 Then
						AddedMsg(a) = MsgList(9)
					End If
					If AddedMsg(a) <> "" Then a = a + 1
				End If
				If i < 0 Or j < 0 Then
					ReDim Preserve DeledMsg(d)
					If i < 0 And j = 0 Then
						DeledMsg(d) = MsgList(7)
					ElseIf i = 0 And j < 0 Then
						DeledMsg(d) = MsgList(8)
					ElseIf i < 0 And j < 0 Then
						DeledMsg(d) = MsgList(9)
					End If
					If DeledMsg(d) <> "" Then d = d + 1
				End If
			ElseIf StringSrc.EndString = "" And StringTrn.EndString <> "" Then
				i = Len(StringTrn.EndString) - Len(LTrim(StringTrn.EndString))
				j = Len(StringTrn.EndString) - Len(RTrim(StringTrn.EndString))
				If i + j <> 0 Then
					ReDim Preserve DeledMsg(d)
					If i > 0 And j = 0 Then
						DeledMsg(d) = MsgList(7)
					ElseIf i = 0 And j > 0 Then
						DeledMsg(d) = MsgList(8)
					ElseIf i > 0 And j > 0 Then
						DeledMsg(d) = MsgList(9)
					End If
					If DeledMsg(d) <> "" Then d = d + 1
				End If
			End If
		End If
	End If

	'ݼǰַƶɾ
	If AsiaKey = 1 Then
		If StringTrn.ExpString <> "" And Trim(StringTrn.ExpString) <> "" Then
			ReDim Preserve MovedMsg(v)
			If StringSrc.AccKey <> "" Or StringTrn.AccKey <> "" Then MovedMsg(v) = MsgList(14)
			If StringSrc.EndSpace <> "" Or StringTrn.EndSpace <> "" Then MovedMsg(v) = MsgList(15)
			If StringSrc.Shortcut <> "" Or StringTrn.Shortcut <> "" Then MovedMsg(v) = MsgList(16)
			If StringSrc.EndString <> "" Or StringTrn.EndString <> "" Then MovedMsg(v) = MsgList(17)
			If MovedMsg(v) <> "" Then v = v + 1
		End If
		If StringTrn.PreString <> "" And Trim(StringTrn.PreString) <> "" Then
			If StringSrc.EndString = "" And StringTrn.EndString = "" Then
				ReDim Preserve MovedMsg(v)
				MovedMsg(v) = MsgList(17)
				v = v + 1
			ElseIf StringSrc.EndString = "" And StringTrn.EndString <> "" Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(18)
				d = d + 1
			ElseIf StringSrc.EndString <> "" And StringTrn.EndString = "" Then
				If Trim(StringSrc.EndString) = Trim(StringTrn.PreString) Then
					ReDim Preserve MovedMsg(v)
					MovedMsg(v) = MsgList(17)
					v = v + 1
				Else
					ReDim Preserve DeledMsg(d)
					DeledMsg(d) = MsgList(18)
					d = d + 1
				End If
			ElseIf StringSrc.EndString <> "" And StringTrn.EndString <> "" Then
				ReDim Preserve DeledMsg(d)
				DeledMsg(d) = MsgList(18)
				d = d + 1
			End If
		End If
	End If
	If MoveAcckey <> "" Then
		ReDim Preserve MovedMsg(v)
		If MoveAcckey = "EndStringSrc" Then
			MovedMsg(v) = MsgList(19)
		ElseIf MoveAcckey = "ShortcutSrc" Then
			MovedMsg(v) = MsgList(20)
		ElseIf MoveAcckey = "EndStringTrn" Then
			MovedMsg(v) = MsgList(21)
		ElseIf MoveAcckey = "ShortcutTrn" Then
			MovedMsg(v) = MsgList(22)
		End If
		If MovedMsg(v) <> "" Then v = v + 1
	End If

	'滻ַ
	If PreRepStr <> "" And AppRepStr <> "" Then
		ReDim Preserve ReplacedMsg(r + 1)
		ReplacedMsg(r) = Replace(PreRepStr,JoinStr,MsgList(28))
		ReplacedMsg(r + 1) = Replace(AppRepStr,JoinStr,MsgList(28))
	ElseIf PreRepStr <> "" And AppRepStr = "" Then
		ReDim Preserve DeledMsg(d)
		DeledMsg(d) = Replace(PreRepStr,JoinStr,MsgList(28))
	End If

	'֯Ϣ
	i = 0
	If CheckArray(ModifiedMsg) = True Then
		Massage(i) = Replace(MsgList(23),"%s",Join(ClearArray(ModifiedMsg,1),MsgList(28)))
		ModifiedCount = ModifiedCount + 1
		i = i + 1
	End If
	If CheckArray(AddedMsg) = True Then
		ReDim Preserve Massage(i)
		Massage(i) = Replace(MsgList(24),"%s",Join(ClearArray(AddedMsg,1),MsgList(28)))
		AddedCount = AddedCount + 1
		i = i + 1
	End If
	If CheckArray(MovedMsg) = True Then
		ReDim Preserve Massage(i)
		Massage(i) = Replace(MsgList(25),"%s",Join(ClearArray(MovedMsg,1),MsgList(28)))
		MovedCount = MovedCount + 1
		i = i + 1
	End If
	If CheckArray(DeledMsg) = True Then
		ReDim Preserve Massage(i)
		Massage(i) = Replace(MsgList(26),"%s",Join(ClearArray(DeledMsg,1),MsgList(28)))
		DeledCount = DeledCount + 1
		i = i + 1
	End If
	If CheckArray(ReplacedMsg) = True Then
		ReDim Preserve Massage(i)
		Massage(i) = Replace(Replace(MsgList(27),"%s",ReplacedMsg(r)),"%d",ReplacedMsg(r + 1))
		ReplacedCount = ReplacedCount + 1
	End If

	If CheckArray(Massage) = True Then ReplaceMassage = Join(Massage,MsgList(29)) & MsgList(30)
End Function


'Ϣ
Function LineErrMassage(ByVal srcLineNum As Integer,ByVal trnLineNum As Integer,LineNumErrCount As Integer) As String
	Dim MsgList() As String
	If getMsgList(UIDataList,MsgList,"LineErrMassage",1) = False Then Exit Function
	If srcLineNum <> trnLineNum Then
		If srcLineNum > trnLineNum Then
			LineErrMassage = Replace(MsgList(80),"%s",CStr(srcLineNum - trnLineNum))
			LineNumErrCount = LineNumErrCount + 1
		ElseIf srcLineNum < trnLineNum Then
			LineErrMassage = Replace(MsgList(81),"%s",CStr(trnLineNum - srcLineNum))
			LineNumErrCount = LineNumErrCount + 1
		End If
	End If
End Function


'ݼϢ
Function AccKeyErrMassage(ByVal srcAccKeyNum As Integer,ByVal trnAccKeyNum As Integer,accKeyNumErrCount As Integer) As String
	Dim MsgList() As String
	If getMsgList(UIDataList,MsgList,"AccKeyErrMassage",1) = False Then Exit Function
	If srcAccKeyNum <> trnAccKeyNum Then
		If srcAccKeyNum > trnAccKeyNum Then
			AccKeyErrMassage = Replace(MsgList(82),"%s",CStr(srcAccKeyNum - trnAccKeyNum))
			accKeyNumErrCount = accKeyNumErrCount + 1
		ElseIf srcAccKeyNum < trnAccKeyNum Then
			AccKeyErrMassage = Replace(MsgList(83),"%s",CStr(trnAccKeyNum - srcAccKeyNum))
			accKeyNumErrCount = accKeyNumErrCount + 1
		End If
	End If
End Function


'Ϣ
Function CountMassage(ByVal ErrorCount As Integer,ByVal LineNumErrCount As Integer,ByVal accKeyNumErrCount As Integer,ByVal ProjectID As Long) As String
	Dim MsgList() As String
	If getMsgList(UIDataList,MsgList,"CountMassage",1) = False Then Exit Function
	Select Case ProjectID
	Case 0
		If ErrorCount = 0 Then
			CountMassage = MsgList(0)
		Else
			CountMassage = MsgList(1) & MsgList(2) & MsgList(3)
			CountMassage = Replace(CountMassage,"%ln",CStr(LineNumErrCount))
			CountMassage = Replace(CountMassage,"%dn",CStr(accKeyNumErrCount))
			CountMassage = Replace(CountMassage,"%s",CStr(ErrorCount))
			CountMassage = Replace(CountMassage,"%m",CStr(ModifiedCount))
			CountMassage = Replace(CountMassage,"%a",CStr(AddedCount))
			CountMassage = Replace(CountMassage,"%v",CStr(MovedCount))
			CountMassage = Replace(CountMassage,"%d",CStr(DeledCount))
			CountMassage = Replace(CountMassage,"%r",CStr(ReplacedCount))
		End If
	Case 1, Is > 3
		If ErrorCount = 0 Then
			CountMassage = MsgList(94)
		Else
			CountMassage = MsgList(11) & MsgList(4) & MsgList(3)
			CountMassage = Replace(CountMassage,"%ln",CStr(LineNumErrCount))
			CountMassage = Replace(CountMassage,"%dn",CStr(accKeyNumErrCount))
			CountMassage = Replace(CountMassage,"%s",CStr(ErrorCount))
			CountMassage = Replace(CountMassage,"%m",CStr(ModifiedCount))
			CountMassage = Replace(CountMassage,"%a",CStr(AddedCount))
			CountMassage = Replace(CountMassage,"%v",CStr(MovedCount))
			CountMassage = Replace(CountMassage,"%d",CStr(DeledCount))
			CountMassage = Replace(CountMassage,"%r",CStr(ReplacedCount))
		End If
	Case 2
		If ErrorCount = 0 Then
			CountMassage = MsgList(89)
		Else
			CountMassage = MsgList(6) & MsgList(7)
			CountMassage = Replace(CountMassage,"%s",CStr(ErrorCount))
			CountMassage = Replace(CountMassage,"%m",CStr(ModifiedCount))
			CountMassage = Replace(CountMassage,"%a",CStr(AddedCount))
			CountMassage = Replace(CountMassage,"%w",CStr(DeledCount))
		End If
	Case 3
		If ErrorCount = 0 Then
			CountMassage = MsgList(92)
		Else
			CountMassage = MsgList(9) & MsgList(7)
			CountMassage = Replace(CountMassage,"%s",CStr(ErrorCount))
			CountMassage = Replace(CountMassage,"%m",CStr(ModifiedCount))
			CountMassage = Replace(CountMassage,"%a",CStr(AddedCount))
			CountMassage = Replace(CountMassage,"%w",CStr(DeledCount))
		End If
	End Select
End Function


'Ϣ
Sub sysErrorMassage(sysError As ErrObject,ByVal fType As Long)
	Dim TempArray() As String,MsgList() As String
	Dim ErrorNumber As Long,ErrorSource As String,ErrorDescription As String
	Dim TitleMsg As String,ContinueMsg As String,Msg As String

	ErrorNumber = sysError.Number
	ErrorSource = sysError.Source
	ErrorDescription = sysError.Description

	TitleMsg = "Error"
	Select Case fType
	Case 0
		ContinueMsg = vbCrLf & vbCrLf & "The program cannot continue and will exit."
	Case 1
		ContinueMsg = vbCrLf & vbCrLf & "Do you want to continue?"
	Case 2
		ContinueMsg = vbCrLf & vbCrLf & "The program will continue to run."
	End Select

	If CheckINIArray(UIDataList) = True Then
		If getMsgList(UIDataList,MsgList,"sysErrorMassage",3) = False Then
			If getMsgList(UIDataList,MsgList,"Main",3) = False Then
				Msg = "The following file is missing [Main|sysErrorMassage] section." & vbCrLf & "%s"
				Msg = Replace(Msg,"%s",LangFile)
			Else
				TitleMsg = MsgList(48)
				If fType <> 0 Then ContinueMsg = MsgList(78) Else ContinueMsg = MsgList(79)
				Msg = Replace(Replace(MsgList(77),"%s","sysErrorMassage"),"%d",LangFile)
			End If
		Else
			TitleMsg = MsgList(0)
			Select Case fType
			Case 0
				ContinueMsg = MsgList(10)
			Case 1
				ContinueMsg = MsgList(11)
			Case 2
				ContinueMsg = MsgList(12)
			End Select

			Select Case ErrorSource
			Case ""
				Msg = Replace(Replace(MsgList(1),"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
			Case "NotSection"
				TempArray = Split(ErrorDescription,JoinStr,-1)
				Msg = Replace(Replace(MsgList(3),"%s",TempArray(1)),"%d",TempArray(0))
			Case "NotValue"
				TempArray = Split(ErrorDescription,JoinStr,-1)
				Msg = Replace(Replace(MsgList(4),"%s",TempArray(1)),"%d",TempArray(0))
			Case "NotReadFile"
				TempArray = Split(ErrorDescription,JoinStr,-1)
				Msg = Replace(MsgList(5),"%s",TempArray(1))
			Case "NotWriteFile"
				TempArray = Split(ErrorDescription,JoinStr,-1)
				Msg = Replace(MsgList(6),"%s",TempArray(1))
			Case "NotINIFile"
				Msg = Replace(MsgList(7),"%s",ErrorDescription)
			Case "NotExitFile"
				Msg = Replace(MsgList(8),"%s",ErrorDescription)
			Case "NotVersion"
				TempArray = Split(ErrorDescription,JoinStr,-1)
				Msg = Replace(MsgList(9),"%s",TempArray(0))
				Msg = Replace(Replace(Msg,"%d",TempArray(1)),"%v",TempArray(2))
			Case Else
				Msg = Replace(MsgList(2),"%s",ErrorSource)
				Msg = Replace(Replace(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
			End Select
		End If
	Else
		Select Case ErrorSource
		Case ""
			Msg = "An Error occurred in the program design." & vbCrLf & "Error Code: %d, Content: %v"
			Msg = Replace(Replace(Msg,"%s",CStr(ErrorNumber)),"%v",ErrorDescription)
		Case "NotSection"
			TempArray = Split(ErrorDescription,JoinStr,-1)
			Msg = "The following file is missing [%s] section." & vbCrLf & "%d"
			Msg = Replace(Replace(Msg,"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotValue"
			TempArray = Split(ErrorDescription,JoinStr,-1)
			Msg = "The following file is missing [%s] Value." & vbCrLf & "%d"
			Msg = Replace(Replace(Msg,"%s",TempArray(1)),"%d",TempArray(0))
		Case "NotReadFile"
			Msg = Replace(ErrorDescription,JoinStr,vbCrLf)
		Case "NotWriteFile"
			Msg = Replace(ErrorDescription,JoinStr,vbCrLf)
		Case "NotINIFile"
			Msg = "The following contents of the file is not correct." & vbCrLf & "%s"
			Msg = Replace(Msg,"%s",ErrorDescription)
		Case "NotExitFile"
			Msg = "The following file does not exist! Please check and try again." & vbCrLf & "%s"
			Msg = Replace(Msg,"%s",ErrorDescription)
		Case "NotVersion"
			TempArray = Split(ErrorDescription,JoinStr,-1)
			Msg = "The following file version is %d, requires version at least %v." & vbCrLf & "%s"
			Msg = Replace(Msg,"%s",TempArray(0))
			Msg = Replace(Replace(Msg,"%d",TempArray(1)),"%v",TempArray(2))
		Case Else
			Msg = "Your system is missing %s server." & vbCrLf & "Error Code: %d, Content: %v"
			Msg = Replace(Msg,"%s",ErrorSource)
			Msg = Replace(Replace(Msg,"%d",CStr(ErrorNumber)),"%v",ErrorDescription)
		End Select
	End If

	If Msg <> "" Then
		'Msg = Msg & ContinueMsg
		Select Case fType
		Case 0
			PSL.Output(TitleMsg & ": "  & Msg)
			Exit All
		Case 1
			PSL.Output(TitleMsg & ": "  & Msg)
			Exit All
		Case Else
			PSL.Output(TitleMsg & ": "  & Msg)
		End Select
	End If
End Sub


'ϲ
Function MergeArray(srcStrArr() As String,trnStrArr() As String) As String()
	Dim i As Long,srcNum As Long,trnNum As Long
	Dim srcPassNum As Long,trnPassNum As Long,TempArray() As String
	srcNum = UBound(srcStrArr)
	trnNum = UBound(trnStrArr)
	ReDim TempArray(srcNum + trnNum + 1) As String
	For i = 0 To (srcNum + trnNum + 1) Step 2
		If srcNum >= srcPassNum Then
			TempArray(i) = srcStrArr(srcPassNum)
			srcPassNum = srcPassNum + 1
		End If
		If trnNum >= trnPassNum Then
			TempArray(i + 1) = trnStrArr(trnPassNum)
			trnPassNum = trnPassNum + 1
		End If
	Next i
	MergeArray = TempArray
End Function


'ִת
Public Function ReConvert(ByVal ConverString As String) As String
	ReConvert = ConverString
	If ReConvert = "" Then Exit Function
	If InStr(ReConvert,"\") Then ReConvert = Replace$(ReConvert,"\","\\")
	If InStr(ReConvert,vbCrLf) Then ReConvert = Replace$(ReConvert,vbCrLf,"\r\n")
	If InStr(ReConvert,vbNewLine) Then ReConvert = Replace$(ReConvert,vbNewLine,"\r\n")
	If InStr(ReConvert,vbCr) Then ReConvert = Replace$(ReConvert,vbCr,"\r")
	If InStr(ReConvert,vbLf) Then ReConvert = Replace$(ReConvert,vbLf,"\n")
	If InStr(ReConvert,vbBack) Then ReConvert = Replace$(ReConvert,vbBack,"\b")
	If InStr(ReConvert,vbFormFeed) Then ReConvert = Replace$(ReConvert,vbFormFeed,"\f")
	If InStr(ReConvert,vbVerticalTab) Then ReConvert = Replace$(ReConvert,vbVerticalTab,"\v")
	If InStr(ReConvert,vbTab) Then ReConvert = Replace$(ReConvert,vbTab,"\t")
	If InStr(ReConvert,vbNullChar) Then ReConvert = Replace$(ReConvert,vbNullChar,"\0")
	ReConvert = ReConvertBRegExp(ReConvert)
End Function


'תչַΪʮת
Private Function ReConvertB(ByVal ConverString As String) As String
	Dim i As Long,Length As Long,Dec As Long,Temp As String
	ReConvertB = ConverString
	i = 1
	Do
		Temp = Mid$(ReConvertB,i,1)
		Dec = AscW(Temp)
		If (Dec > 0 And Dec < 32) Or (Dec > 126 And Dec < 256) Then
			ReConvertB = Replace$(ReConvertB,Temp,"\x" & Right$("0" & Hex$(Dec),2))
			i = i + 3
		End If
		Length = Len(ReConvertB)
		i = i + 1
	Loop Until i > Length
End Function


'תչַΪʮת
Private Function ReConvertBRegExp(ByVal ConverString As String) As String
	Dim i As Long,ConvCode As String,Matches As Object
	ReConvertBRegExp = ConverString
	With RegExp
		.Global = True
		.IgnoreCase = True
		.Pattern = "[\x01-\x1F\x7F-\xFF]"
		Set Matches = .Execute(ConverString)
		If Matches.Count > 0 Then
			For i = 0 To Matches.Count - 1
				ConvCode = Right$("0" & Hex$(AscW(Matches(i).Value)),2)
				ReConvertBRegExp = Replace$(ReConvertBRegExp,Matches(i).Value,"\x" & ConvCode)
			Next i
		End If
	End With
End Function


'ִת
Public Function Convert(ByVal ConverString As String) As String
	Convert = ConverString
	If Convert = "" Then Exit Function
	If InStr(Convert,"\") = 0 Then Exit Function
	If InStr(Convert,"\\") Then Convert = Replace$(Convert,"\\","*a!N!d*")
	If InStr(Convert,"\r\n") Then Convert = Replace$(Convert,"\r\n",vbCrLf)
	If InStr(Convert,"\r\n") Then Convert = Replace$(Convert,"\r\n",vbNewLine)
	If InStr(Convert,"\r") Then Convert = Replace$(Convert,"\r",vbCr)
	If InStr(Convert,"\r") Then Convert = Replace$(Convert,"\r",vbNewLine)
	If InStr(Convert,"\n") Then Convert = Replace$(Convert,"\n",vbLf)
	If InStr(Convert,"\b") Then Convert = Replace$(Convert,"\b",vbBack)
	If InStr(Convert,"\f") Then Convert = Replace$(Convert,"\f",vbFormFeed)
	If InStr(Convert,"\v") Then Convert = Replace$(Convert,"\v",vbVerticalTab)
	If InStr(Convert,"\t") Then Convert = Replace$(Convert,"\t",vbTab)
	If InStr(Convert,"\'") Then Convert = Replace$(Convert,"\'","'")
	If InStr(Convert,"\""") Then Convert = Replace$(Convert,"\""","""")
	If InStr(Convert,"\?") Then Convert = Replace$(Convert,"\?","?")
	If InStr(Convert,"\") Then Convert = ConvertBRegExp(Convert)
	If InStr(Convert,"\0") Then Convert = Replace$(Convert,"\0",vbNullChar)
	If InStr(Convert,"*a!N!d*") Then Convert = Replace$(Convert,"*a!N!d*","\")
End Function


'ת˽ƻʮת
Private Function ConvertB(ByVal ConverString As String) As String
	Dim i As Long,j As Long,EscStr As String,ConvCode As String
	ConvertB = ConverString
	i = InStr(ConvertB,"\")
	Do While i > 0
		EscStr = Mid$(ConvertB,i,2)
		Select Case EscStr
		Case "\x", "\X"
			ConvCode = Mid$(ConvertB,i + 2,2)
			If CheckStr(UCase$(ConvCode),CheckHexStr(0).AscRange,1) = True Then
				j = Val("&H" & ConvCode)
				ConvertB = Replace$(ConvertB,EscStr & ConvCode,Val2Bytes(j,2))
			End If
		Case "\u", "\U"
			ConvCode = Mid$(ConvertB,i + 2,4)
			If CheckStr(UCase$(ConvCode),CheckHexStr(1).AscRange,1) = True Then
				j = Val("&H" & ConvCode)
				ConvertB = Replace$(ConvertB,EscStr & ConvCode,Val2Bytes(j,2))
			End If
		Case Is <> ""
			EscStr = "\"
			For j = 3 To 1 Step -1
				ConvCode = Mid$(ConvertB,i + 1,j)
				If CheckStr(ConvCode,CheckHexStr(2).AscRange,1) = True Then
					j = Val("&O" & ConvCode)
					If j > 256 Then
						ConvCode = Left$(ConvCode,2)
						j = Val("&O" & ConvCode)
					End If
					ConvertB = Replace$(ConvertB,EscStr & ConvCode,Val2Bytes(j,2))
					Exit For
				End If
			Next j
		End Select
		i = InStr(i + 1,ConvertB,"\")
	Loop
End Function


'ת˽ƻʮת
Private Function ConvertBRegExp(ByVal ConverString As String) As String
	Dim i As Long,j As Long,CodeVal As Long,Matches As Object
	ConvertBRegExp = ConverString
	With RegExp
		.Global = True
		.IgnoreCase = True
		For i = 0 To UBound(CheckHexStr)
			.Pattern = CheckHexStr(i).Range
			Set Matches = .Execute(ConverString)
			If Matches.Count > 0 Then
				For j = 0 To Matches.Count - 1
					If i = 0 Then
						If Matches(j).Length = 4 Then
							CodeVal = Val("&H" & Mid$(Matches(j).Value,3))
							ConvertBRegExp = Replace$(ConvertBRegExp,Matches(j).Value,Val2Bytes(CodeVal,2))
						End If
					ElseIf i = 1 Then
						If Matches(j).Length = 6 Then
							CodeVal = Val("&H" & Mid$(Matches(j).Value,3))
							ConvertBRegExp = Replace$(ConvertBRegExp,Matches(j).Value,Val2Bytes(CodeVal,2))
						End If
					ElseIf Matches(j).Length > 1 And Matches(j).Length < 5 Then
						CodeVal = Val("&O" & Replace$(Matches(j).Value,"\",""))
						If CodeVal > 256 Then
							Matches(j).Value = Left$(Matches(j).Value,3)
							CodeVal = Val("&O" & Replace$(Matches(j).Value,"\",""))
						End If
						ConvertBRegExp = Replace$(ConvertBRegExp,Matches(j).Value,Val2Bytes(CodeVal,2))
					End If
				Next j
			End If
		Next i
	End With
End Function


'תֵΪֽ
Public Function Val2Bytes(ByVal Value As Long,ByVal Length As Integer) As Byte()
	On Error GoTo errHandle
	ReDim Bytes(Length - 1) As Byte
	CopyMemory Bytes(0), Value, Length
	Val2Bytes = Bytes
	Exit Function
	errHandle:
	ReDim Bytes(0) As Byte
	Val2Bytes = Bytes
End Function


'ת HEX ֵΪ Long 
Public Function HexToIntArray(ByVal HexRange As String) As Long()
	Dim i As Long,n As Long,TempList() As Long
	Dim HexValue() As String,TempArray() As String
	If HexRange = "" Then
		ReDim TempList(1) As Long
		HexToIntArray = TempList
		Exit Function
	End If
	HexValue = Split(HexRange,",",-1)
	n = UBound(HexValue)
	ReDim TempList(n * 2 + 1) As Long
	For i = 0 To n
		TempArray = Split(HexValue(i),"-")
		If UBound(TempArray) > 0 Then
			If TempArray(0) <> "" Then
				TempList(i * 2) = Val("&H" & TempArray(0))
			Else
				TempList(i * 2) = -1
			End If
			If TempArray(1) <> "" Then
				TempList(i * 2 + 1) = Val("&H" & TempArray(1))
			Else
				TempList(i * 2 + 1) = -1
			End If
		Else
			If TempArray(0) <> "" Then
				TempList(i * 2) = Val("&H" & TempArray(0))
				TempList(i * 2 + 1) = TempList(i * 2)
			Else
				TempList(i * 2) = -1
				TempList(i * 2 + 1) = -1
			End If
		End If
	Next i
	HexToIntArray = TempList
End Function


'תַΪֵ
Public Function StrToLong(ByVal mStr As String,Optional ByVal DefaultValue As Long) As Long
	On Error GoTo errHandle
	StrToLong = CLng(mStr)
	Exit Function
	errHandle:
	StrToLong = DefaultValue
End Function


'ȡִ
Function GetCheckSet(ByVal SelSet As String,ByVal Path As String) As Long
	Dim i As Long,j As Long,k As Long,m As Long,n As Long,x As Long
	Dim Header As String,Temp As String,OldVersion As String
	Dim TempArray() As String,SetsArray() As String,DataList() As INIFILE_DATA

	ReDim SetsArray(17)
	If SelSet = DefaultCheckList(0) Then
		SelSet = "en2zh"
	ElseIf SelSet = DefaultCheckList(1) Then
		SelSet = "zh2en"
	End If

	If Path = CheckRegKey Then GoTo GetFromRegistry
	If Path = "" Then Path = CheckFilePath
	If Dir(Path) = "" Then GoTo GetFromRegistry
	If getINIFile(DataList,Path,"_autodetect_all",1) = False Then Exit Function
	For i = 0 To UBound(DataList)
		With DataList(i)
			Select Case .Title
			Case "Option" 		'ȡ Option ֵ
				For j = 0 To UBound(.Item)
					If .Item(j) = "Version" Then OldVersion = .Value(j)
					If SelSet = "" Or SelSet = "Option" Then
						Select Case .Item(j)
						Case "UILanguageID"
							cSelected(0) = .Value(j)
						Case "AutoMacroSet"
							cSelected(1) = .Value(j)
						Case "CheckMacroSet"
							cSelected(2) = .Value(j)
						Case "AutoMacroCheck"
							cSelected(3) = .Value(j)
						Case "AutoSelection"
							cSelected(4) = .Value(j)
						Case "SelectedCheck"
							cSelected(5) = .Value(j)
						Case "CheckAllType"
							cSelected(6) = .Value(j)
						Case "CheckMenu"
							cSelected(7) = .Value(j)
						Case "CheckDialog"
							cSelected(8) = .Value(j)
						Case "CheckString"
							cSelected(9) = .Value(j)
						Case "CheckAcceleratorTable"
							cSelected(10) = .Value(j)
						Case "CheckVersion"
							cSelected(11) = .Value(j)
						Case "CheckOther"
							cSelected(12) = .Value(j)
						Case "CheckSeletedOnly"
							cSelected(13) = .Value(j)
						Case "CheckAllCont"
							cSelected(14) = .Value(j)
						Case "CheckAccKey"
							cSelected(15) = .Value(j)
						Case "CheckEndChar"
							cSelected(16) = .Value(j)
						Case "CheckAcceler"
							cSelected(17) = .Value(j)
						Case "IgnoreVerTag"
							cSelected(18) = .Value(j)
						Case "IgnoreSetTag"
							cSelected(19) = .Value(j)
						Case "IgnoreDateTag"
							cSelected(20) = .Value(j)
						Case "IgnoreStateTag"
							cSelected(21) = .Value(j)
						Case "TgnoreAllTag"
							cSelected(22) = .Value(j)
						Case "NoCheckTag"
							cSelected(23) = .Value(j)
						Case "NoChangeTrnState"
							cSelected(24) = .Value(j)
						Case "AutoRepString"
							cSelected(25) = .Value(j)
						Case "KeepSettings"
							cSelected(26) = .Value(j)
						End Select
					End If
				Next j
				If SelSet = "" Or SelSet = "Option" Then
					Select Case cSelected(1)
					Case "Default", "en2zh"
						cSelected(1) = DefaultCheckList(0)
					Case "zh2en"
						cSelected(1) = DefaultCheckList(1)
					End Select
					Select Case cSelected(2)
					Case "Default", "en2zh"
						cSelected(2) = DefaultCheckList(0)
					Case "zh2en"
						cSelected(2) = DefaultCheckList(1)
					End Select
					If SelSet = "Option" Then
						If CheckArray(cSelected) = True Then GetCheckSet = 1
						Exit For
					End If
				End If
			Case "Projects" 		'ȡ Project ֵ
				If SelSet = "" Or SelSet = "Project" Then
					For j = 0 To UBound(.Item)
						Select Case .Item(j)
						Case "CheckOnly"
							.Item(j) = DefaultProjectList(0)
						Case "CheckAndCorrect"
							.Item(j) = DefaultProjectList(1)
						Case "DelAccessKey"
							.Item(j) = DefaultProjectList(2)
						Case "DelAccelerator"
							.Item(j) = DefaultProjectList(3)
						Case "DelAccessKeyAndAccelerator"
							.Item(j) = DefaultProjectList(4)
						End Select
						If .Item(j) <> "" Then
							CreateArray(.Item(j),.Item(j) & JoinStr & .Value(j),ProjectList,ProjectDataList)
							k = k + 1
						End If
					Next j
					If SelSet = "Project" Then
						If k > 0 Then GetCheckSet = 3
						Exit For
					End If
				End If
			Case Is <> "Update"
				If SelSet = "" Or SelSet = "Sets" Or SelSet = .Title Then 'ȡ Option ȫֵ
					For j = 0 To UBound(.Item)
						Select Case .Item(j)
						Case "ExcludeChar"
							SetsArray(0) = .Value(j)
						Case "LineSplitChar"
							SetsArray(1) = .Value(j)
						Case "CheckBracket"
							SetsArray(2) = .Value(j)
						Case "KeepCharPair"
							SetsArray(3) = .Value(j)
						Case "ShowAsiaKey"
							SetsArray(4) = .Value(j)
						Case "CheckEndChar"
							SetsArray(5) = .Value(j)
						Case "NoTrnEndChar"
							SetsArray(6) = .Value(j)
						Case "AutoTrnEndChar"
							SetsArray(7) = .Value(j)
						Case "CheckShortChar"
							SetsArray(8) = .Value(j)
						Case "CheckShortKey"
							SetsArray(9) = .Value(j)
						Case "KeepShortKey"
							SetsArray(10) = .Value(j)
						Case "PreRepString"
							SetsArray(11) = .Value(j)
						Case "AutoRepString"
							SetsArray(12) = .Value(j)
						Case "AccessKeyChar"
							SetsArray(13) = .Value(j)
						Case "AddAccessKeyWithFirstChar"
							SetsArray(14) = .Value(j)
						Case "LineSplitMode"
							SetsArray(15) = .Value(j)
						Case "AppInsertSplitChar"
							SetsArray(16) = .Value(j)
						Case "ReplaceSplitChar"
							SetsArray(17) = .Value(j)
						Case "ApplyLangList"
							LngPair = .Value(j)
						End Select
					Next j
					Temp = Join(SetsArray,"")
					If Temp <> "" And Temp <> "0" And Temp <> "1" Then
						Select Case .Title
						Case "en2zh"
							.Title = DefaultCheckList(0)
						Case "zh2en"
							.Title = DefaultCheckList(1)
						End Select
						If LngPair <> "" Then
							LngPair = Replace$(LngPair,LngJoinStr,LngJoinStr & LngJoinStr)
						Else
							LngPair = Join(LangCodeList(.Title,1,108),SubLngJoinStr)
						End If
						Temp = .Title & JoinStr & Join(SetsArray,SubJoinStr) & JoinStr & LngPair
						'¾ɰĬֵ
						If StrComp(ToUpdateCheckVersion,OldVersion) = 1 Then
							Temp = CheckDataUpdate(.Title,Temp)
						End If
						'ݵ
						CreateArray(.Title,Temp,CheckList,CheckDataList)
						x = x + 1
					End If
					'ݳʼ
					ReDim SetsArray(17)
					LngPair = ""
					n = n + 1
				End If
			End Select
		End With
	Next i
	If x = n Then GetCheckSet = 4
	If GetCheckSet = 0 Then GoTo GetFromRegistry
	Exit Function

	GetFromRegistry:
	'ȡ Option ֵ
	OldVersion = GetSetting("AccessKey","Option","Version","")
	If SelSet = "" Or SelSet = "Option" Then
		cSelected(0) = GetSetting("AccessKey","Option","UILanguageID",0)
		cSelected(1) = GetSetting("AccessKey","Option","AutoMacroSet","")
		cSelected(2) = GetSetting("AccessKey","Option","CheckMacroSet","")
		cSelected(3) = GetSetting("AccessKey","Option","AutoMacroCheck",1)
		cSelected(4) = GetSetting("AccessKey","Option","AutoSelection",1)
		cSelected(5) = GetSetting("AccessKey","Option","SelectedCheck",0)
		cSelected(6) = GetSetting("AccessKey","Option","CheckAllType",0)
		cSelected(7) = GetSetting("AccessKey","Option","CheckMenu",0)
		cSelected(8) = GetSetting("AccessKey","Option","CheckDialog",0)
		cSelected(9) = GetSetting("AccessKey","Option","CheckString",0)
		cSelected(10) = GetSetting("AccessKey","Option","CheckAcceleratorTable",0)
		cSelected(11) = GetSetting("AccessKey","Option","CheckVersion",0)
		cSelected(12) = GetSetting("AccessKey","Option","CheckOther",0)
		cSelected(13) = GetSetting("AccessKey","Option","CheckSeletedOnly",1)
		cSelected(14) = GetSetting("AccessKey","Option","CheckAllCont",0)
		cSelected(15) = GetSetting("AccessKey","Option","CheckAccKey",0)
		cSelected(16) = GetSetting("AccessKey","Option","CheckEndChar",0)
		cSelected(17) = GetSetting("AccessKey","Option","CheckAcceler",0)
		cSelected(18) = GetSetting("AccessKey","Option","IgnoreVerTag",0)
		cSelected(19) = GetSetting("AccessKey","Option","IgnoreSetTag",0)
		cSelected(20) = GetSetting("AccessKey","Option","IgnoreDateTag",0)
		cSelected(21) = GetSetting("AccessKey","Option","IgnoreStateTag",0)
		cSelected(22) = GetSetting("AccessKey","Option","TgnoreAllTag",1)
		cSelected(23) = GetSetting("AccessKey","Option","NoCheckTag",1)
		cSelected(24) = GetSetting("AccessKey","Option","NoChangeTrnState",0)
		cSelected(25) = GetSetting("AccessKey","Option","AutoRepString",0)
		cSelected(26) = GetSetting("AccessKey","Option","KeepSetting",1)
		Select Case cSelected(1)
		Case "Default", "en2zh"
			cSelected(1) = DefaultCheckList(0)
		Case "zh2en"
			cSelected(1) = DefaultCheckList(1)
		End Select
		Select Case cSelected(2)
		Case "Default", "en2zh"
			cSelected(2) = DefaultCheckList(0)
		Case "zh2en"
			cSelected(2) = DefaultCheckList(1)
		End Select
		If SelSet = "Option" Then
			If CheckArray(cSelected) = True Then GetCheckSet = 1
			Exit Function
		End If
	End If
	'ȡ Project ֵ
	If SelSet = "" Or SelSet = "Project" Then
		k = 0
		On Error GoTo NextItem
		TempArray = GetAllSettings("AccessKey","Projects")
		For i = LBound(TempArray) To UBound(TempArray)
			If TempArray(i,0) <> "" And TempArray(i,1) <> "" Then
				Select Case TempArray(i,0)
				Case "CheckOnly"
					TempArray(i,0) = DefaultProjectList(0)
				Case "CheckAndCorrect"
					TempArray(i,0) = DefaultProjectList(1)
				Case "DelAccessKey"
					TempArray(i,0) = DefaultProjectList(2)
				Case "DelAccelerator"
					TempArray(i,0) = DefaultProjectList(3)
				Case "DelAccessKeyAndAccelerator"
					TempArray(i,0) = DefaultProjectList(4)
				End Select
				CreateArray(TempArray(i,0),TempArray(i,0) & JoinStr & TempArray(i,1),ProjectList,ProjectDataList)
				k = k + 1
			End If
		Next i
		On Error GoTo 0
		NextItem:
		If SelSet = "Project" Then
			If k > 0 Then GetCheckSet = 3
			Exit Function
		End If
	End If
	'ȡ Option ֵ
	If SelSet = "" Or SelSet = "Sets" Then
		Header = GetSetting("AccessKey","Option","Headers","")
		If Header <> "" Then
			ReDim SetsArray(17)
			TempArray = Split(Header,";",-1)
			n = UBound(TempArray): x = 0
			For i = 0 To n
				If TempArray(i) <> "" Then
					'תɰÿֵ
					Header = GetSetting("AccessKey",TempArray(i),"Name","")
				End If
				If Header = "" Then Header = TempArray(i)
				SetsArray(0) = GetSetting("AccessKey",TempArray(i),"ExcludeChar","")
				SetsArray(1) = GetSetting("AccessKey",TempArray(i),"LineSplitChar","")
				SetsArray(2) = GetSetting("AccessKey",TempArray(i),"CheckBracket","")
				SetsArray(3) = GetSetting("AccessKey",TempArray(i),"KeepCharPair","")
				SetsArray(4) = GetSetting("AccessKey",TempArray(i),"ShowAsiaKey","")
				SetsArray(5) = GetSetting("AccessKey",TempArray(i),"CheckEndChar","")
				SetsArray(6) = GetSetting("AccessKey",TempArray(i),"NoTrnEndChar","")
				SetsArray(7) = GetSetting("AccessKey",TempArray(i),"AutoTrnEndChar","")
				SetsArray(8) = GetSetting("AccessKey",TempArray(i),"CheckShortChar","")
				SetsArray(9) = GetSetting("AccessKey",TempArray(i),"CheckShortKey","")
				SetsArray(10) = GetSetting("AccessKey",TempArray(i),"KeepShortKey","")
				SetsArray(11) = GetSetting("AccessKey",TempArray(i),"PreRepString","")
				SetsArray(12) = GetSetting("AccessKey",TempArray(i),"AutoRepString","")
				SetsArray(13) = GetSetting("AccessKey",TempArray(i),"AccessKeyChar","")
				SetsArray(14) = GetSetting("AccessKey",TempArray(i),"AddAccessKeyWithFirstChar","")
				SetsArray(15) = GetSetting("AccessKey",TempArray(i),"LineSplitMode","")
				SetsArray(16) = GetSetting("AccessKey",TempArray(i),"AppInsertSplitChar","")
				SetsArray(17) = GetSetting("AccessKey",TempArray(i),"ReplaceSplitChar","")
				LngPair = GetSetting("AccessKey",TempArray(i),"ApplyLangList","")
				Temp = Join(SetsArray,"")
				If Temp <> "" And Temp <> "0" And Temp <> "1" Then
					Select Case Header
					Case "en2zh"
						Header = DefaultCheckList(0)
					Case "zh2en"
						Header = DefaultCheckList(1)
					End Select
					If LngPair <> "" Then
						LngPair = Replace$(LngPair,LngJoinStr,LngJoinStr & LngJoinStr)
					Else
						LngPair = Join(LangCodeList(Header,1,108),SubLngJoinStr)
					End If
					Temp = Header & JoinStr & Join(SetsArray,SubJoinStr) & JoinStr & LngPair
					'¾ɰĬֵ
					If StrComp(ToUpdateCheckVersion,OldVersion) = 1 Then
						Temp = CheckDataUpdate(Header,Temp)
					End If
					'ݵ
					CreateArray(Header,Temp,CheckList,CheckDataList)
					x = x + 1
				End If
			Next i
			If x = n + 1 Then GetCheckSet = 4
		End If
	End If
End Function


'¼ɰ汾ֵ
Function CheckDataUpdate(ByVal Header As String,ByVal Data As String) As String
	Dim UpdatedData As String,uV As String,dV As String,spStr As String,Stemp As Boolean
	Dim i As Long,j As Long,m As Long,uDataList() As String,dDataList() As String,dSetsArray() As String
	CheckDataUpdate = Data
	For i = LBound(DefaultCheckList) To UBound(DefaultCheckList)
		If DefaultCheckList(i) = Header Then
			Stemp = True
			Exit For
		End If
	Next i
	If Stemp = False Then Exit Function
	spStr = CheckSettings(Header,0)
	If CheckDataUpdate = spStr Then Exit Function
	dSetsArray = Split(spStr,SubJoinStr)
	If CheckArray(dSetsArray) = False Then Exit Function
	TempArray = Split(Data,JoinStr)
	uSetsArray = Split(TempArray(1),SubJoinStr)
	For i = 0 To UBound(uSetsArray)
		uV = uSetsArray(i)
		dV = dSetsArray(i)
		If Trim(uV) = "" Or i = 1 Or i = 6 Then uV = dV
		If i <> 4 And i <> 14 And i <> 15 And i < 18 And uV <> "" And uV <> dV Then
			If i = 5 Or i = 7 Then spStr = " " Else spStr = ","
			If i = 7 And InStr(uV,"|") = 0 Then
				uDataList = Split(uV,spStr)
				For m = 0 To UBound(uDataList)
					uV = uDataList(m)
					uDataList(m) = Left(Trim(uV),1) & "|" & Right(Trim(uV),1)
				Next m
				uV = Join(uDataList,spStr)
			End If
			uV = Join(ClearArray(Split(uV & spStr & dV,spStr,-1)),spStr)
		End If
		uSetsArray(i) = uV
	Next i
	TempArray(1) = Join(uSetsArray,SubJoinStr)
	CheckDataUpdate = Join(TempArray,JoinStr)
End Function


'ӻĿ
Function CreateArray(ByVal Header As String,ByVal Data As String,HeaderList() As String,DataList() As String) As Boolean
	Dim i As Long,n As Long,FindHeader As String,Stemp As Boolean
	If HeaderList(0) = "" Then
		HeaderList(0) = Header
		DataList(0) = Data
		CreateArray = True
	Else
		n = UBound(HeaderList)
		FindHeader = LCase$(Header)
		For i = LBound(HeaderList) To n
			If LCase$(HeaderList(i)) = FindHeader Then
				If DataList(i) <> Data Then DataList(i) = Data
				Stemp = True
				Exit For
			End If
		Next i
		If Stemp = False Then
			n = n + 1
			ReDim Preserve HeaderList(n),DataList(n)
			HeaderList(n) = Header
			If DataList(n) <> Data Then DataList(n) = Data
			CreateArray = True
		End If
	End If
End Function


'ֵָǷ
Function getCheckID(DataList() As String,ByVal LngCode As String,ByVal OldLngCode As String) As Long
	Dim i As Long,j As Long,FindCode As String,Stemp As Boolean
	Stemp = False
	FindCode = LCase(LngCode)
	For i = LBound(DataList) To UBound(DataList)
		TempArray = Split(DataList(i),JoinStr)
		If TempArray(2) <> "" Then
			LangArray = Split(TempArray(2),SubLngJoinStr)
			For j = 0 To UBound(LangArray)
				If LCase(Split(LangArray(j),LngJoinStr)(2)) = FindCode Then
					getCheckID = i
					Stemp = True
					Exit For
				End If
			Next j
		End If
		If Stemp = True Then Exit For
	Next i
	If Stemp = False Then
		If OldLngCode = "Asia" Then getCheckID = 0 Else getCheckID = 1
	End If
End Function


'ִַݹ鷨ִ
'Mode = False С򣬷ӴСl = ߽磬r = ұ߽.
Sub SortArrayByLength(ByRef MyArray As Variant, ByVal l As Long, ByVal r As Long, ByVal Mode As Boolean)
	Dim i As Long, j As Long, TmpX As Variant, TmpA As Variant
	i = l: j = r: TmpX = Len(MyArray((l + r) \ 2))
	While (i <= j)
		If Mode = False Then
			While (Len(MyArray(i)) < TmpX And i < r)
				i = i + 1
			Wend
			While (TmpX < Len(MyArray(j)) And j > l)
				j = j - 1
			Wend
		Else
			While (Len(MyArray(i)) > TmpX And i < r)
				i = i + 1
			Wend
			While (TmpX > Len(MyArray(j)) And j > l)
				j = j - 1
			Wend
		End If
		If (i <= j) Then
			TmpA = MyArray(i)
			MyArray(i) = MyArray(j)
			MyArray(j) = TmpA
			i = i + 1: j = j - 1
		End If
	Wend
	If (l < j) Then Call SortArrayByLength(MyArray, l, j, Mode)
	If (i < r) Then Call SortArrayByLength(MyArray, i, r, Mode)
End Sub


'ظ
'Mode = 0 
Function ClearArray(xArray() As String,Optional ByVal Mode As Long) As String()
	Dim i As Long,n As Long,yArray() As String,Dic As Object
	ClearArray = xArray
	n = UBound(xArray)
	If n = 0 Then Exit Function
	Set Dic = CreateObject("Scripting.Dictionary")
	ReDim yArray(n)
	n = 0
	For i = LBound(xArray) To UBound(xArray)
		If Mode > 0 Then
			If xArray(i) <> "" Then
				If Not Dic.Exists(xArray(i)) Then
					Dic.Add(xArray(i),"")
					yArray(n) = xArray(i)
					n = n + 1
				End If
			End If
		ElseIf Not Dic.Exists(xArray(i)) Then
			Dic.Add(xArray(i),"")
			yArray(n) = xArray(i)
			n = n + 1
		End If
	Next i
	If n > 0 Then n = n - 1
	ReDim Preserve yArray(n)
	ClearArray = yArray
End Function


'ִǷΪգǿշ True
Function CheckArray(DataList() As String) As Boolean
	Dim i As Long
	On Error GoTo errHandle
	For i = LBound(DataList) To UBound(DataList)
		If DataList(i) <> "" Then
			CheckArray = True
			Exit For
		End If
	Next i
	errHandle:
End Function


' INI ǷΪգǿշ True
Function CheckINIArray(DataList() As INIFILE_DATA) As Boolean
	Dim i As Long
	On Error GoTo errHandle
	For i = LBound(DataList) To UBound(DataList)
		If DataList(i).Title <> "" Then
			CheckINIArray = True
			Exit For
		End If
	Next i
	errHandle:
End Function


'ֵָͨ
Function CheckKeyCode(ByVal FindKey As String,ByVal CheckKey As String) As Long
	Dim FindStr As String,Key As String,Pos As Long
	Key = Trim(FindKey)
	If InStr(Key,"%") Then Key = Replace(Key,"%","x")
	If CheckKey <> "" And Key <> "" Then
		FindStrArr = Split(Convert(CheckKey),",",-1)
		For i = 0 To UBound(FindStrArr)
			FindStr = Trim(FindStrArr(i))
			If InStr(FindStr,"%") Then FindStr = Replace(FindStr,"%","x")
			If InStr(FindStr,"-") Then
				If Left(FindStr,1) <> "[" And Right(FindStr,1) <> "]" Then
					FindStr = "[" & FindStr & "]"
				End If
			End If
			Pos = InStr(FindStr,"[")
			If Pos > 0 Then
				If Left(FindStr,Pos-1) <> "[" And Right(FindStr,Pos+1) <> "]" Then
					FindStr = Replace(FindStr,"[","[[]")
				End If
			End If
			'PSL.Output Key & " : " &  FindStr  '
			If UCase(Key) Like UCase(FindStr) = True Then
				CheckKeyCode = 1
				Exit For
			End If
		Next i
	ElseIf CheckKey = "" And Key <> "" Then
		CheckKeyCode = 1
	End If
End Function


'ȥִǰָ PreStr  AppStr
'fType = 0 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 1 ȥִǰĿոָ PreStr  AppStrȥִǰո
'fType = 2 ȥִǰĿոָ PreStr  AppStr 1 Σȥִǰո
'fType > 2 ȥִǰĿոָ PreStr  AppStr 1 Σȥִǰո
Public Function RemoveBackslash(ByVal Path As String,ByVal PreStr As String,ByVal AppStr As String,ByVal fType As Long) As String
	Dim i As Long,a As Long,p As Long,Stemp As Boolean
	RemoveBackslash = Path
	If Path = "" Then Exit Function
	a = Len(AppStr)
	p = Len(PreStr)
	RemoveBackslash = Trim(RemoveBackslash)
	Do
		Stemp = False
		If p <> 0 Then
			If Left$(RemoveBackslash,p) = PreStr Then
				RemoveBackslash = Mid$(RemoveBackslash,p + 1)
				Stemp = True
			End If
		End If
		If a <> 0 Then
			If Right$(RemoveBackslash,a) = AppStr Then
				RemoveBackslash = Left$(RemoveBackslash,Len(RemoveBackslash) - a)
				Stemp = True
			End If
		End If
		If fType = 1 Or fType > 2 Then RemoveBackslash = Trim$(RemoveBackslash)
		If Stemp = True Then
			If fType < 2 Then i = 0 Else i = 1
		Else
			i = 1
		End If
	Loop Until i = 1
End Function


' ȡıļ
Function ReadFile(ByVal FilePath As String,CharSet As String) As String
	Dim i As Long,objStream As Object,Code As String,FN As Variant
	If Dir$(FilePath) = "" Then Exit Function
	i = FileLen(FilePath)
	If i = 0 Then Exit Function
	On Error Resume Next
	Set objStream = CreateObject("Adodb.Stream")
	On Error GoTo ErrorMsg
	Code = CharSet
	If Not objStream Is Nothing Then
		'If Code = "" Then Code = CheckCode(FilePath)
		If Code = "" Then Code = "_autodetect_all"
		If Code <> "ANSI" Then
			With objStream
				.Type = 2
				.Mode = 3
				.Charset = IIf(Code = "utf-8EFBB","utf-8",Code)
				.Open
				.LoadFromFile FilePath
				ReadFile = .ReadText
				.Close
			End With
		End If
	End If
	If objStream Is Nothing Or Code = "ANSI" Then
		ReDim readByte(i - 1) As Byte
		FN = FreeFile
		Open FilePath For Binary Access Read As #FN
		Get #FN,,readByte
		Close #FN
		ReadFile = StrConv$(readByte,vbUnicode)
	End If
	If CharSet = "" Then CharSet = Code
	Set objStream = Nothing
	Exit Function

	ErrorMsg:
	ReadFile = ""
	If objStream Is Nothing Or Code = "ANSI" Then Close #FN
	Set objStream = Nothing
	Err.Source = "NotReadFile"
	Err.Description = Err.Description & JoinStr & FilePath
	Call sysErrorMassage(Err,1)
End Function


'ȡԶ
Function LangCodeList(ByVal DataName As String,ByVal MinNum As Long,ByVal MaxNum As Long) As String()
	Dim i As Long,LangMaxNum As Long,LangCode As String,LangName As String,Stemp As Boolean
	Dim LangPairs() As String,TempList() As String

	If CheckArray(PslLangDataList) = False Then
		PslLangCode = "|af|sq|am|ar|hy|as|az|ba|eu|be|BN|bs|br|bg|ca|zh-CN|zh-TW|co|hr|cs|da|nl|" & _
				"en|et|fo|fa|fil-PH|fi|fr|fy|gl|ka|de|el|kl|gu|ha|he|hi|hu|is|id|iu|ga|xh|zu|it|" & _
				"ja|kn|KS|kk|km|rw|kok|ko|kz|ky|lo|lv|lt|lb|mk|ms|ML|mt|mi|mr|mn|ne|no|nb|" & _
				"nn|or|ps|pl|pt|pa|qu|ro|ru|se|sa|sr|st|tn|SD|si|sk|sl|es|sw|sv|sy|tg|ta|tt|" & _
				"te|th|bo|tr|tk|ug|uk|ur|uz|vi|cy|wo"
		PslLangDataList = Split(PslLangCode,LngJoinStr)
		Stemp = True
	End If

	en2zhCheck = "||||||||||||||||zh-CN|zh-TW|||||||||||||||||||||||||||||||ja|||||||ko|||||||" & _
				"||||||||||||||||||||||||||||||||||||||||||||||"

	zh2enCheck = "|af|sq|am|ar|hy|as|az|ba|eu|be|BN|bs|br|bg|ca|||co|hr|cs|da|nl|" & _
				"en|et|fo|fa|fil-PH|fi|fr|fy|gl|ka|de|el|kl|gu|ha|he|hi|hu|is|id|iu|ga|xh|zu|it|" & _
				"|kn|KS|kk|km|rw|kok||kz|ky|lo|lv|lt|lb|mk|ms|ML|mt|mi|mr|mn|ne|no|nb|" & _
				"nn|or|ps|pl|pt|pa|qu|ro|ru|se|sa|sr|st|tn|SD|si|sk|sl|es|sw|sv|sy|tg|ta|tt|" & _
				"te|th|bo|tr|tk|ug|uk|ur|uz|vi|cy|wo"

	LangMaxNum = UBound(PslLangDataList)
	If MaxNum > LangMaxNum Then MaxNum = LangMaxNum
	ReDim TempList(LangMaxNum),LangPairs(MaxNum - MinNum)

	Select Case DataName
	Case DefaultCheckList(0)
		TempList = Split(en2zhCheck,LngJoinStr)
	Case DefaultCheckList(1)
		TempList = Split(zh2enCheck,LngJoinStr)
	End Select

	For i = 0 To LangMaxNum
		If Stemp = True Then
			LangCode = PslLangDataList(i)
			'If LangCode = "zh-CN" Or LangCode = "zh-TW" Or LangCode = "fil-PH" Then
			'	LangName = PSL.GetLangCode(PSL.GetLangID(LangCode,pslCodeLangRgn),pslCodeText)
			'Else
			'	LangName = PSL.GetLangCode(PSL.GetLangID(LangCode,pslCode639_1),pslCodeText)
			'	If LangName = "3FF3F" Then
			'		LangName = PSL.GetLangCode(PSL.GetLangID(LangCode,pslCodeLangRgn),pslCodeText)
			'	End If
			'End If
			PslLangDataList(i) = LangName & LngJoinStr & LangCode
		End If
		If i >= MinNum And i <= MaxNum Then
			LangPairs(i - MinNum) = PslLangDataList(i) & LngJoinStr & TempList(i)
		End If
	Next i
	LangCodeList = LangPairs
End Function


'ԴблȡָĿĿб
'Mode = 0 ֱ˳Mode = 1 Ƿ˳ʾ
Function getMsgList(SourceList() As INIFILE_DATA,TargetList() As String,Titles As String,ByVal Mode As Long) As Boolean
	Dim i As Long,j As Long,n As Long,m As Long,Temp As String
	Temp = "|" & Titles & "|"
	n = -1
	For i = 0 To UBound(SourceList)
		If InStr(Temp,"|" & SourceList(i).Title & "|") > 0 Then
			If n = -1 Then
				TargetList = SourceList(i).Value
				n = UBound(TargetList)
			Else
				m = UBound(SourceList(i).Value)
				ReDim Preserve TargetList(n + m + 1) As String
				For j = 0 To m
					TargetList(n + 1) = SourceList(i).Value(j)
				Next j
			End If
			Temp = Replace$(Temp,"|" & SourceList(i).Title & "|","")
			If Temp = "" Then Exit For
		End If
	Next i
	If n > -1 Then
		Titles = RemoveBackslash(Temp,"|","|",1)
		getMsgList = True
	Else
		If Mode = 0 Then
			Err.Raise(1,"NotSection",LangFile & JoinStr & Titles)
		ElseIf Mode < 3 Then
			On Error GoTo ErrorMassage
			Err.Raise(1,"NotSection",LangFile & JoinStr & Titles)
			ErrorMassage:
			Call sysErrorMassage(Err,Mode)
		End If
	End If
End Function


'ȡ INI ļ
'Mode = 0 ɾĿֵǰո񣬲תĿֵ
'Mode = 1 ɾĿֵǰո񣬲ת
'Mode > 1 ɾĿֵǰո񣬲ת
Function getINIFile(DataList() As INIFILE_DATA,ByVal File As String,Code As String,ByVal Mode As Long) As Boolean
	Dim i As Long,m As Long,n As Long,j As Long,Max As Long
	Dim ItemList() As String,ValueList() As String,TempArray() As String
	Dim l As String,Header As String,HeaderBak As String,Temp As String
	If Trim$(File) <> "" Then
		TempArray = Split(ReadFile(File,Code),vbCrLf)
	ElseIf File = "" And Code <> "" Then
		TempArray = Split(Code,vbCrLf)
	Else
		Exit Function
	End If
	If CheckArray(TempArray) = False Then Exit Function
	Max = UBound(TempArray)
	For i = 0 To Max
		l$ = Trim(TempArray(i)): j = 0
		If l$ <> "" Then
			If Left$(l$,1) = "[" And Right$(l$,1) = "]" Then
				Header$ = Trim$(Mid$(l$,2,Len(l$)-2))
			End If
			If Header$ <> "" And HeaderBak$ = "" Then HeaderBak$ = Header$
			If Header$ <> "" And Header$ = HeaderBak$ Then
				j = InStr(l$,"=")
				If j > 0 Then
					Temp$ = Trim$(Left$(l$,j - 1))
					If Temp$ <> "" Then
						ReDim Preserve ItemList(n),ValueList(n)
						ItemList(n) = Temp$
						If Mode = 0 Then
							ValueList(n) = Convert(RemoveBackslash(Mid$(l$,j + 1),"""","""",2))
						ElseIf Mode = 1 Then
							ValueList(n) = LTrim$(Mid$(l$,j + 1))
						Else
							ValueList(n) = Mid$(l$,j + 1)
						End If
						n = n + 1
					End If
				End If
			End If
		End If
		If n > 0 Then
			If Header$ <> "" And (i = Max Or Header$ <> HeaderBak$) Then
				ReDim Preserve DataList(m) As INIFILE_DATA
				DataList(m).Title = HeaderBak$
				DataList(m).Item = ItemList
				DataList(m).Value = ValueList
				m = m + 1
				n = 0
				getINIFile = True
			End If
			HeaderBak$ = Header$
		End If
	Next i
End Function


'ȡļб
Function GetUIList(ByVal UIDir As String,UIList() As UI_FILE) As Boolean
	Dim i As Long,j As Long,n As Long,Max As Long,readByte() As Byte,FN As Variant
	Dim l As String,File As String,Header As String
	Dim TempArray() As String,tmpUIFile As UI_FILE
	File = Dir$(UIDir & AppName & "_*.lng")
	Do While File <> ""
		If LCase$(Mid$(File,InStrRev(File,".") + 1)) = "lng" Then
			tmpUIFile.FilePath = UIDir & File
			i = FileLen(tmpUIFile.FilePath)
			ReDim readByte(i) As Byte
			On Error Resume Next
			FN = FreeFile
			Open tmpUIFile.FilePath For Binary Access Read Lock Write As #FN
			Get #FN,,readByte
			Close #FN
			On Error GoTo 0
			TempArray = Split(readByte,vbCrLf)
			Max = UBound(TempArray)
			For i = 0 To Max
				l$ = Trim(TempArray(i))
				If l$ <> "" Then
					If Left$(l$,1) = "[" And Right$(l$,1) = "]" Then
						Header$ = Trim$(Mid$(l$,2,Len(l$) - 2))
					End If
					If Header$ = "Option" Then
						j = InStr(l$,"=")
						If j > 0 Then
							Select Case Trim$(Left$(l$,j - 1))
							Case "AppName"
								tmpUIFile.AppName = RemoveBackslash(Mid$(l$,j + 1),"""","""",1)
							Case "Version"
								tmpUIFile.Version = RemoveBackslash(Mid$(l$,j + 1),"""","""",1)
							Case "LanguageName"
								tmpUIFile.LangName = RemoveBackslash(Mid$(l$,j + 1),"""","""",1)
							Case "LanguageID"
								tmpUIFile.LangID = RemoveBackslash(Mid$(l$,j + 1),"""","""",1)
							Case "Encoding"
								tmpUIFile.Encoding = RemoveBackslash(Mid$(l$,j + 1),"""","""",1)
							End Select
						End If
					End If
				End If
				If Header$ <> "" And (i = Max Or Header$ <> "Option") Then
					Header = ""
					Exit For
				End If
			Next i
			If LCase$(tmpUIFile.AppName) = LCase$(AppName) Then
				If tmpUIFile.Version = Version And tmpUIFile.LangName <> "" Then
					n = n + 1
					ReDim Preserve UIList(n) As UI_FILE,LngList(n) As String
					UIList(n) = tmpUIFile
					tmpUIFile.AppName = ""
					tmpUIFile.Version = ""
					tmpUIFile.LangName = ""
					tmpUIFile.LangID = ""
					tmpUIFile.Encoding = ""
					GetUIList = True
				End If
			End If
		End If
		File = Dir$()
	Loop
End Function
